namespace birch {
#line 97 "src/delay/Delay.birch"
#line 97 "src/delay/Delay.birch"
Delay_::Delay_() :
    #line 97 "src/delay/Delay.birch"
    base_type_(),
    #line 101 "src/delay/Delay.birch"
    child(),
    #line 108 "src/delay/Delay.birch"
    coparent(),
    #line 113 "src/delay/Delay.birch"
    n(Integer(1)) {
  //
}

#line 120 "src/delay/Delay.birch"
#line 120 "src/delay/Delay.birch"
#line 120 "src/delay/Delay.birch"
void Delay_::graft(const Delay& node) {
  #line 121 "src/delay/Delay.birch"
  assert(!(child.has_value()));
  #line 122 "src/delay/Delay.birch"
  this->child = node;
}

#line 132 "src/delay/Delay.birch"
#line 132 "src/delay/Delay.birch"
#line 132 "src/delay/Delay.birch"
void Delay_::graft(const Delay& node, const Integer& n) {
  #line 133 "src/delay/Delay.birch"
  assert(!(child.has_value()));
  #line 134 "src/delay/Delay.birch"
  this->n = n;
  #line 135 "src/delay/Delay.birch"
  this->child = node;
}

#line 143 "src/delay/Delay.birch"
#line 143 "src/delay/Delay.birch"
#line 143 "src/delay/Delay.birch"
void Delay_::graftReplace(const Delay& node) {
  #line 144 "src/delay/Delay.birch"
  assert(child.has_value());
  #line 145 "src/delay/Delay.birch"
  this->child = node;
}

#line 155 "src/delay/Delay.birch"
#line 155 "src/delay/Delay.birch"
#line 155 "src/delay/Delay.birch"
void Delay_::graftReplace(const Delay& node, const Integer& n) {
  #line 156 "src/delay/Delay.birch"
  assert(child.has_value());
  #line 157 "src/delay/Delay.birch"
  this->n = n;
  #line 158 "src/delay/Delay.birch"
  this->child = node;
}

#line 168 "src/delay/Delay.birch"
#line 168 "src/delay/Delay.birch"
#line 168 "src/delay/Delay.birch"
Delay Delay_::prune() {
  #line 169 "src/delay/Delay.birch"
  assert(!(child.has_value()));
  #line 170 "src/delay/Delay.birch"
  return this->shared_from_this_();
}

#line 180 "src/delay/Delay.birch"
#line 180 "src/delay/Delay.birch"
#line 180 "src/delay/Delay.birch"
Delay Delay_::prune(const Integer& n) {
  #line 181 "src/delay/Delay.birch"
  assert(n == Integer(1));
  #line 182 "src/delay/Delay.birch"
  return prune();
}

#line 188 "src/delay/Delay.birch"
#line 188 "src/delay/Delay.birch"
#line 188 "src/delay/Delay.birch"
Boolean Delay_::isGrandChildOf(const Delay& node) {
  #line 189 "src/delay/Delay.birch"
  return node->child.has_value() && node->child.value()->child.has_value() && node->child.value()->child.value() == this->shared_from_this_();
}

#line 197 "src/delay/Delay.birch"
#line 197 "src/delay/Delay.birch"
#line 197 "src/delay/Delay.birch"
void Delay_::join(const Delay& node) {
  #line 198 "src/delay/Delay.birch"
  assert(!(coparent.has_value()));
  #line 199 "src/delay/Delay.birch"
  assert(!(node->coparent.has_value()));
  #line 200 "src/delay/Delay.birch"
  coparent = node;
  #line 201 "src/delay/Delay.birch"
  node->coparent = this->shared_from_this_();
}

}
