namespace birch {
#line 73 "src/distribution/matrix_gaussian/MatrixGaussianDistribution.birch"
#line 73 "src/distribution/matrix_gaussian/MatrixGaussianDistribution.birch"
libbirch::DefaultArray<Real,2> simulate_matrix_gaussian(const libbirch::DefaultArray<Real,2>& M, const libbirch::DefaultArray<Real,2>& U, const libbirch::DefaultArray<Real,2>& V) {
  #line 75 "src/distribution/matrix_gaussian/MatrixGaussianDistribution.birch"
  assert(rows(M) == rows(U));
  #line 76 "src/distribution/matrix_gaussian/MatrixGaussianDistribution.birch"
  assert(rows(M) == columns(U));
  #line 77 "src/distribution/matrix_gaussian/MatrixGaussianDistribution.birch"
  assert(columns(M) == rows(V));
  #line 78 "src/distribution/matrix_gaussian/MatrixGaussianDistribution.birch"
  assert(columns(M) == columns(V));
  auto N = rows(M);
  auto P = columns(M);
  auto Z = matrix_lambda([=](const Integer& i, const Integer& j) -> Real {
    #line 82 "src/distribution/matrix_gaussian/MatrixGaussianDistribution.birch"
    return simulate_gaussian(0.0, 1.0);
  }, N, P);
  #line 84 "src/distribution/matrix_gaussian/MatrixGaussianDistribution.birch"
  return M + outer(chol(U) * Z, chol(V));
}

}
