namespace birch {
}
namespace birch {
#line 108 "src/distribution/matrix_normal_inverse_wishart/MatrixNormalInverseWishartDistribution.birch"
#line 108 "src/distribution/matrix_normal_inverse_wishart/MatrixNormalInverseWishartDistribution.birch"
libbirch::DefaultArray<Real,2> simulate_matrix_normal_inverse_wishart(const libbirch::DefaultArray<Real,2>& N, const libbirch::DefaultArray<Real,2>& \u039b, const libbirch::DefaultArray<Real,2>& \u03a8, const Real& k) {
  auto \u03a3 = cholinv(\u039b);
  auto M = \u03a3 * N;
  #line 112 "src/distribution/matrix_normal_inverse_wishart/MatrixNormalInverseWishartDistribution.birch"
  return simulate_matrix_t(k, M, \u03a3, \u03a8);
}

}
namespace birch {
#line 109 "src/distribution/matrix_normal_inverse_wishart/MatrixNormalInverseWishartMatrixGaussianDistribution.birch"
#line 109 "src/distribution/matrix_normal_inverse_wishart/MatrixNormalInverseWishartMatrixGaussianDistribution.birch"
libbirch::DefaultArray<Real,2> simulate_matrix_normal_inverse_wishart_matrix_gaussian(const libbirch::DefaultArray<Real,2>& N, const libbirch::DefaultArray<Real,2>& \u039b, const libbirch::DefaultArray<Real,2>& \u03a8, const Real& k, const libbirch::DefaultArray<Real,2>& U) {
  auto S = cholinv(\u039b);
  auto M = S * N;
  auto \u03a3 = U + S;
  #line 114 "src/distribution/matrix_normal_inverse_wishart/MatrixNormalInverseWishartMatrixGaussianDistribution.birch"
  return simulate_matrix_t(k, M, \u03a3, \u03a8);
}

}
namespace birch {
#line 119 "src/distribution/matrix_normal_inverse_wishart/ScaledMatrixNormalInverseWishartMatrixGaussianDistribution.birch"
#line 119 "src/distribution/matrix_normal_inverse_wishart/ScaledMatrixNormalInverseWishartMatrixGaussianDistribution.birch"
libbirch::DefaultArray<Real,2> simulate_scaled_matrix_normal_inverse_wishart_matrix_gaussian(const libbirch::DefaultArray<Real,2>& A, const libbirch::DefaultArray<Real,2>& N, const libbirch::DefaultArray<Real,2>& \u039b, const libbirch::DefaultArray<Real,2>& \u03a8, const Real& k, const libbirch::DefaultArray<Real,2>& U) {
  auto S = cholinv(\u039b);
  auto M = A * S * N;
  auto \u03a3 = U + outer(A * S, A);
  #line 125 "src/distribution/matrix_normal_inverse_wishart/ScaledMatrixNormalInverseWishartMatrixGaussianDistribution.birch"
  return simulate_matrix_t(k, M, \u03a3, \u03a8);
}

}
