namespace birch {
}
namespace birch {
#line 65 "src/distribution/multivariate_gaussian/MultivariateGaussianDistribution.birch"
#line 65 "src/distribution/multivariate_gaussian/MultivariateGaussianDistribution.birch"
libbirch::DefaultArray<Real,1> simulate_multivariate_gaussian(const libbirch::DefaultArray<Real,1>& \u03bc, const libbirch::DefaultArray<Real,2>& \u03a3) {
  #line 66 "src/distribution/multivariate_gaussian/MultivariateGaussianDistribution.birch"
  assert(length(\u03bc) == rows(\u03a3));
  #line 67 "src/distribution/multivariate_gaussian/MultivariateGaussianDistribution.birch"
  assert(length(\u03bc) == columns(\u03a3));
  auto n = length(\u03bc);
  auto z = vector_lambda([=](const Integer& i) -> Real {
    #line 70 "src/distribution/multivariate_gaussian/MultivariateGaussianDistribution.birch"
    return simulate_gaussian(0.0, 1.0);
  }, n);
  #line 72 "src/distribution/multivariate_gaussian/MultivariateGaussianDistribution.birch"
  return \u03bc + chol(\u03a3) * z;
}

}
namespace birch {
#line 94 "src/distribution/multivariate_gaussian/MultivariateGaussianMultivariateGaussianDistribution.birch"
#line 94 "src/distribution/multivariate_gaussian/MultivariateGaussianMultivariateGaussianDistribution.birch"
libbirch::DefaultArray<Real,1> simulate_multivariate_gaussian_multivariate_gaussian(const libbirch::DefaultArray<Real,1>& \u03bc, const libbirch::DefaultArray<Real,2>& \u03a3, const libbirch::DefaultArray<Real,2>& S) {
  #line 96 "src/distribution/multivariate_gaussian/MultivariateGaussianMultivariateGaussianDistribution.birch"
  return simulate_multivariate_gaussian(\u03bc, \u03a3 + S);
}

}
namespace birch {
#line 102 "src/distribution/multivariate_gaussian/ScaledMultivariateGaussianMultivariateGaussianDistribution.birch"
#line 102 "src/distribution/multivariate_gaussian/ScaledMultivariateGaussianMultivariateGaussianDistribution.birch"
libbirch::DefaultArray<Real,1> simulate_scaled_multivariate_gaussian_multivariate_gaussian(const libbirch::DefaultArray<Real,2>& A, const libbirch::DefaultArray<Real,1>& \u03bc, const libbirch::DefaultArray<Real,2>& \u03a3, const libbirch::DefaultArray<Real,2>& S) {
  #line 104 "src/distribution/multivariate_gaussian/ScaledMultivariateGaussianMultivariateGaussianDistribution.birch"
  return simulate_multivariate_gaussian(A * \u03bc, outer(A * \u03a3, A) + S);
}

}
