namespace birch {
#line 30 "src/event/Handler.birch"
#line 30 "src/event/Handler.birch"
Handler_::Handler_(const Boolean& delaySampling, const Boolean& delayExpressions) :
    #line 30 "src/event/Handler.birch"
    base_type_(),
    #line 34 "src/event/Handler.birch"
    \u03c0(),
    #line 39 "src/event/Handler.birch"
    b1(),
    #line 40 "src/event/Handler.birch"
    i1(),
    #line 41 "src/event/Handler.birch"
    i2(),
    #line 42 "src/event/Handler.birch"
    r1(),
    #line 43 "src/event/Handler.birch"
    r2(),
    #line 44 "src/event/Handler.birch"
    r3(),
    #line 49 "src/event/Handler.birch"
    n(Integer(0)),
    #line 54 "src/event/Handler.birch"
    w(0.0),
    #line 59 "src/event/Handler.birch"
    delaySampling(delaySampling),
    #line 64 "src/event/Handler.birch"
    delayExpressions(delayExpressions) {
  //
}

#line 240 "src/event/Handler.birch"
#line 240 "src/event/Handler.birch"
#line 240 "src/event/Handler.birch"
Real Handler_::peek() {
  #line 241 "src/event/Handler.birch"
  if (\u03c0.has_value()) {
    #line 242 "src/event/Handler.birch"
    return \u03c0.value()->peek();
  } else {
    #line 244 "src/event/Handler.birch"
    return 0.0;
  }
}

#line 251 "src/event/Handler.birch"
#line 251 "src/event/Handler.birch"
#line 251 "src/event/Handler.birch"
libbirch::DefaultArray<Real,1> Handler_::args() {
  #line 253 "src/event/Handler.birch"
  n = Integer(0);
  #line 254 "src/event/Handler.birch"
  if (r1.has_value()) {
    #line 255 "src/event/Handler.birch"
    n = n + argSizeReverse(r1.value());
  }
  #line 257 "src/event/Handler.birch"
  if (r2.has_value()) {
    #line 258 "src/event/Handler.birch"
    n = n + argSizeReverse(r2.value());
  }
  #line 260 "src/event/Handler.birch"
  if (r3.has_value()) {
    #line 261 "src/event/Handler.birch"
    n = n + argSizeReverse(r3.value());
  }
  libbirch::DefaultArray<Real,1> x(libbirch::make_shape(n));
  auto i = Integer(1);
  #line 267 "src/event/Handler.birch"
  if (r1.has_value()) {
    auto iter1 = r1.value()->walk();
    #line 269 "src/event/Handler.birch"
    while (iter1->hasNext()) {
      auto v = iter1->next();
      #line 271 "src/event/Handler.birch"
      x(i) = v->peek();
      #line 272 "src/event/Handler.birch"
      i = i + Integer(1);
    }
  }
  #line 275 "src/event/Handler.birch"
  if (r2.has_value()) {
    auto iter2 = r2.value()->walk();
    #line 277 "src/event/Handler.birch"
    while (iter2->hasNext()) {
      auto v = iter2->next();
      auto m = i + v->size() - Integer(1);
      #line 280 "src/event/Handler.birch"
      x(libbirch::make_range(i, m)) = v->peek();
      #line 281 "src/event/Handler.birch"
      i = m + Integer(1);
    }
  }
  #line 284 "src/event/Handler.birch"
  if (r3.has_value()) {
    auto iter3 = r3.value()->walk();
    #line 286 "src/event/Handler.birch"
    while (iter3->hasNext()) {
      auto v = iter3->next();
      auto m = i + v->size() - Integer(1);
      #line 289 "src/event/Handler.birch"
      x(libbirch::make_range(i, m)) = vec(v->peek());
      #line 290 "src/event/Handler.birch"
      i = m + Integer(1);
    }
  }
  #line 293 "src/event/Handler.birch"
  assert(i == n + Integer(1));
  #line 294 "src/event/Handler.birch"
  return x;
}

#line 300 "src/event/Handler.birch"
#line 300 "src/event/Handler.birch"
#line 300 "src/event/Handler.birch"
libbirch::DefaultArray<Real,1> Handler_::grad() {
  libbirch::DefaultArray<Real,1> d(libbirch::make_shape(n));
  #line 302 "src/event/Handler.birch"
  if (\u03c0.has_value()) {
    #line 304 "src/event/Handler.birch"
    \u03c0.value()->grad(1.0);
    auto i = Integer(1);
    #line 308 "src/event/Handler.birch"
    if (r1.has_value()) {
      auto iter1 = r1.value()->walk();
      #line 310 "src/event/Handler.birch"
      while (iter1->hasNext()) {
        auto v = iter1->next();
        #line 312 "src/event/Handler.birch"
        d(i) = v->d.value();
        #line 313 "src/event/Handler.birch"
        i = i + Integer(1);
      }
    }
    #line 316 "src/event/Handler.birch"
    if (r2.has_value()) {
      auto iter2 = r2.value()->walk();
      #line 318 "src/event/Handler.birch"
      while (iter2->hasNext()) {
        auto v = iter2->next();
        auto j = i + v->size() - Integer(1);
        #line 321 "src/event/Handler.birch"
        d(libbirch::make_range(i, j)) = v->d.value();
        #line 322 "src/event/Handler.birch"
        i = j + Integer(1);
      }
    }
    #line 325 "src/event/Handler.birch"
    if (r3.has_value()) {
      auto iter3 = r3.value()->walk();
      #line 327 "src/event/Handler.birch"
      while (iter3->hasNext()) {
        auto v = iter3->next();
        auto j = i + v->size() - Integer(1);
        #line 330 "src/event/Handler.birch"
        d(libbirch::make_range(i, j)) = vec(v->d.value());
        #line 331 "src/event/Handler.birch"
        i = j + Integer(1);
      }
    }
    #line 334 "src/event/Handler.birch"
    assert(i == n + Integer(1));
  }
  #line 336 "src/event/Handler.birch"
  return d;
}

#line 342 "src/event/Handler.birch"
#line 342 "src/event/Handler.birch"
#line 342 "src/event/Handler.birch"
Real Handler_::move(const libbirch::DefaultArray<Real,1>& x) {
  auto p = 0.0;
  #line 344 "src/event/Handler.birch"
  if (\u03c0.has_value()) {
    auto i = Integer(1);
    #line 347 "src/event/Handler.birch"
    if (r1.has_value()) {
      auto iter1 = r1.value()->walk();
      #line 349 "src/event/Handler.birch"
      while (iter1->hasNext()) {
        auto v = iter1->next();
        #line 351 "src/event/Handler.birch"
        v->move(x(i));
        #line 352 "src/event/Handler.birch"
        i = i + Integer(1);
      }
    }
    #line 355 "src/event/Handler.birch"
    if (r2.has_value()) {
      auto iter2 = r2.value()->walk();
      #line 357 "src/event/Handler.birch"
      while (iter2->hasNext()) {
        auto v = iter2->next();
        auto j = i + v->size() - Integer(1);
        #line 360 "src/event/Handler.birch"
        v->move(x(libbirch::make_range(i, j)));
        #line 361 "src/event/Handler.birch"
        i = j + Integer(1);
      }
    }
    #line 364 "src/event/Handler.birch"
    if (r3.has_value()) {
      auto iter3 = r3.value()->walk();
      #line 366 "src/event/Handler.birch"
      while (iter3->hasNext()) {
        auto v = iter3->next();
        auto j = i + v->size() - Integer(1);
        #line 369 "src/event/Handler.birch"
        v->move(mat(x(libbirch::make_range(i, j)), v->columns()));
        #line 370 "src/event/Handler.birch"
        i = j + Integer(1);
      }
    }
    #line 373 "src/event/Handler.birch"
    assert(i == n + Integer(1));
    #line 376 "src/event/Handler.birch"
    p = \u03c0.value()->reval();
  }
  #line 378 "src/event/Handler.birch"
  return p;
}

#line 386 "src/event/Handler.birch"
#line 386 "src/event/Handler.birch"
#line 386 "src/event/Handler.birch"
void Handler_::label(const Integer& gen) {
  #line 387 "src/event/Handler.birch"
  if (\u03c0.has_value()) {
    #line 388 "src/event/Handler.birch"
    \u03c0.value()->label(gen);
  }
}

#line 397 "src/event/Handler.birch"
#line 397 "src/event/Handler.birch"
#line 397 "src/event/Handler.birch"
void Handler_::constant(const Integer& gen) {
  #line 398 "src/event/Handler.birch"
  if (\u03c0.has_value()) {
    #line 399 "src/event/Handler.birch"
    \u03c0.value()->constant(gen);
  }
}

#line 403 "src/event/Handler.birch"
#line 403 "src/event/Handler.birch"
#line 403 "src/event/Handler.birch"
void Handler_::arg(const Random<Boolean>& x) {
  #line 404 "src/event/Handler.birch"
  if (!(b1.has_value())) {
    #line 405 "src/event/Handler.birch"
    b1 = construct<Tape<Random<Boolean>>>();
  }
  #line 407 "src/event/Handler.birch"
  b1.value()->pushBack(x);
  auto p = x->getDistribution()->logpdfLazy(x);
  #line 409 "src/event/Handler.birch"
  if (p.has_value()) {
    #line 410 "src/event/Handler.birch"
    if (\u03c0.has_value()) {
      #line 411 "src/event/Handler.birch"
      \u03c0 = box(\u03c0.value() + p.value());
    } else {
      #line 413 "src/event/Handler.birch"
      \u03c0 = box(p.value());
    }
  }
}

#line 418 "src/event/Handler.birch"
#line 418 "src/event/Handler.birch"
#line 418 "src/event/Handler.birch"
void Handler_::arg(const Random<Integer>& x) {
  #line 419 "src/event/Handler.birch"
  if (!(i1.has_value())) {
    #line 420 "src/event/Handler.birch"
    i1 = construct<Tape<Random<Integer>>>();
  }
  #line 422 "src/event/Handler.birch"
  i1.value()->pushBack(x);
  auto p = x->getDistribution()->logpdfLazy(x);
  #line 424 "src/event/Handler.birch"
  if (p.has_value()) {
    #line 425 "src/event/Handler.birch"
    if (\u03c0.has_value()) {
      #line 426 "src/event/Handler.birch"
      \u03c0 = box(\u03c0.value() + p.value());
    } else {
      #line 428 "src/event/Handler.birch"
      \u03c0 = box(p.value());
    }
  }
}

#line 433 "src/event/Handler.birch"
#line 433 "src/event/Handler.birch"
#line 433 "src/event/Handler.birch"
void Handler_::arg(const Random<libbirch::DefaultArray<Integer,1>>& x) {
  #line 434 "src/event/Handler.birch"
  if (!(i2.has_value())) {
    #line 435 "src/event/Handler.birch"
    i2 = construct<Tape<Random<libbirch::DefaultArray<Integer,1>>>>();
  }
  #line 437 "src/event/Handler.birch"
  i2.value()->pushBack(x);
  auto p = x->getDistribution()->logpdfLazy(x);
  #line 439 "src/event/Handler.birch"
  if (p.has_value()) {
    #line 440 "src/event/Handler.birch"
    if (\u03c0.has_value()) {
      #line 441 "src/event/Handler.birch"
      \u03c0 = box(\u03c0.value() + p.value());
    } else {
      #line 443 "src/event/Handler.birch"
      \u03c0 = box(p.value());
    }
  }
}

#line 448 "src/event/Handler.birch"
#line 448 "src/event/Handler.birch"
#line 448 "src/event/Handler.birch"
void Handler_::arg(const Random<Real>& x) {
  #line 449 "src/event/Handler.birch"
  if (!(r1.has_value())) {
    #line 450 "src/event/Handler.birch"
    r1 = construct<Tape<Random<Real>>>();
  }
  #line 452 "src/event/Handler.birch"
  r1.value()->pushBack(x);
  auto p = x->getDistribution()->logpdfLazy(x);
  #line 454 "src/event/Handler.birch"
  if (p.has_value()) {
    #line 455 "src/event/Handler.birch"
    if (\u03c0.has_value()) {
      #line 456 "src/event/Handler.birch"
      \u03c0 = box(\u03c0.value() + p.value());
    } else {
      #line 458 "src/event/Handler.birch"
      \u03c0 = box(p.value());
    }
  }
}

#line 463 "src/event/Handler.birch"
#line 463 "src/event/Handler.birch"
#line 463 "src/event/Handler.birch"
void Handler_::arg(const Random<libbirch::DefaultArray<Real,1>>& x) {
  #line 464 "src/event/Handler.birch"
  if (!(r2.has_value())) {
    #line 465 "src/event/Handler.birch"
    r2 = construct<Tape<Random<libbirch::DefaultArray<Real,1>>>>();
  }
  #line 467 "src/event/Handler.birch"
  r2.value()->pushBack(x);
  auto p = x->getDistribution()->logpdfLazy(x);
  #line 469 "src/event/Handler.birch"
  if (p.has_value()) {
    #line 470 "src/event/Handler.birch"
    if (\u03c0.has_value()) {
      #line 471 "src/event/Handler.birch"
      \u03c0 = box(\u03c0.value() + p.value());
    } else {
      #line 473 "src/event/Handler.birch"
      \u03c0 = box(p.value());
    }
  }
}

#line 478 "src/event/Handler.birch"
#line 478 "src/event/Handler.birch"
#line 478 "src/event/Handler.birch"
void Handler_::arg(const Random<libbirch::DefaultArray<Real,2>>& x) {
  #line 479 "src/event/Handler.birch"
  if (!(r3.has_value())) {
    #line 480 "src/event/Handler.birch"
    r3 = construct<Tape<Random<libbirch::DefaultArray<Real,2>>>>();
  }
  #line 482 "src/event/Handler.birch"
  r3.value()->pushBack(x);
  auto p = x->getDistribution()->logpdfLazy(x);
  #line 484 "src/event/Handler.birch"
  if (p.has_value()) {
    #line 485 "src/event/Handler.birch"
    if (\u03c0.has_value()) {
      #line 486 "src/event/Handler.birch"
      \u03c0 = box(\u03c0.value() + p.value());
    } else {
      #line 488 "src/event/Handler.birch"
      \u03c0 = box(p.value());
    }
  }
}

}
#line 1 "src/event/handle.birch"

/*
 * Event handler for each thread.
 */
static thread_local birch::Handler handler(std::in_place, true, false);
namespace birch {
#line 11 "src/event/handle.birch"
#line 11 "src/event/handle.birch"
Handler get_handler() {
  #line 12 "src/event/handle.birch"

  return ::handler;
  }

#line 25 "src/event/handle.birch"
#line 25 "src/event/handle.birch"
void set_handler(const Handler& handler) {
  #line 26 "src/event/handle.birch"

  ::handler = handler;
  }

#line 43 "src/event/handle.birch"
#line 43 "src/event/handle.birch"
Handler swap_handler(const Handler& handler) {
  #line 44 "src/event/handle.birch"

  auto& current = ::handler;
  auto previous = handler;
  std::swap(current, previous);
  return previous;
  }

}
