namespace birch {
#line 1 "src/form/binary_other/Add.birch"
#line 1 "src/form/binary_other/Add.birch"
AddFunction_::AddFunction_() {
  //
}

#line 42 "src/form/binary_other/Add.birch"
#line 42 "src/form/binary_other/Add.birch"
libbirch::DefaultArray<Integer,1> operator+(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 43 "src/form/binary_other/Add.birch"

  return x.toEigen().operator+(y.toEigen());
  }

#line 51 "src/form/binary_other/Add.birch"
#line 51 "src/form/binary_other/Add.birch"
libbirch::DefaultArray<Real,1> operator+(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 52 "src/form/binary_other/Add.birch"

  return x.toEigen().cast<Real>().operator+(y.toEigen());
  }

#line 60 "src/form/binary_other/Add.birch"
#line 60 "src/form/binary_other/Add.birch"
libbirch::DefaultArray<Real,1> operator+(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 61 "src/form/binary_other/Add.birch"

  return x.toEigen().operator+(y.toEigen().cast<Real>());
  }

#line 69 "src/form/binary_other/Add.birch"
#line 69 "src/form/binary_other/Add.birch"
libbirch::DefaultArray<Real,1> operator+(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 70 "src/form/binary_other/Add.birch"

  return x.toEigen().operator+(y.toEigen());
  }

#line 78 "src/form/binary_other/Add.birch"
#line 78 "src/form/binary_other/Add.birch"
libbirch::DefaultArray<Integer,2> operator+(const libbirch::DefaultArray<Integer,2>& x, const libbirch::DefaultArray<Integer,2>& y) {
  #line 79 "src/form/binary_other/Add.birch"

  return x.toEigen().operator+(y.toEigen());
  }

#line 87 "src/form/binary_other/Add.birch"
#line 87 "src/form/binary_other/Add.birch"
libbirch::DefaultArray<Real,2> operator+(const libbirch::DefaultArray<Integer,2>& x, const libbirch::DefaultArray<Real,2>& y) {
  #line 88 "src/form/binary_other/Add.birch"

  return x.toEigen().cast<Real>().operator+(y.toEigen());
  }

#line 96 "src/form/binary_other/Add.birch"
#line 96 "src/form/binary_other/Add.birch"
libbirch::DefaultArray<Real,2> operator+(const libbirch::DefaultArray<Real,2>& x, const libbirch::DefaultArray<Integer,2>& y) {
  #line 97 "src/form/binary_other/Add.birch"

  return x.toEigen().operator+(y.toEigen().cast<Real>());
  }

#line 105 "src/form/binary_other/Add.birch"
#line 105 "src/form/binary_other/Add.birch"
libbirch::DefaultArray<Real,2> operator+(const libbirch::DefaultArray<Real,2>& x, const libbirch::DefaultArray<Real,2>& y) {
  #line 106 "src/form/binary_other/Add.birch"

  return x.toEigen().operator+(y.toEigen());
  }

}
namespace birch {
#line 1 "src/form/binary_other/CopySign.birch"
#line 1 "src/form/binary_other/CopySign.birch"
CopySignFunction_::CopySignFunction_() {
  //
}

#line 23 "src/form/binary_other/CopySign.birch"
#line 23 "src/form/binary_other/CopySign.birch"
Integer copysign(const Integer& l, const Integer& r) {
  #line 24 "src/form/binary_other/CopySign.birch"
  return if_then_else(r >= Integer(0), abs(l), -(abs(l)));
}

#line 30 "src/form/binary_other/CopySign.birch"
#line 30 "src/form/binary_other/CopySign.birch"
Real copysign(const Real& l, const Real& r) {
  #line 31 "src/form/binary_other/CopySign.birch"

  return std::copysign(l, r);
  }

#line 39 "src/form/binary_other/CopySign.birch"
#line 39 "src/form/binary_other/CopySign.birch"
Real copysign(const Integer& l, const Real& r) {
  #line 40 "src/form/binary_other/CopySign.birch"
  return copysign(scalar<Real>(l), r);
}

#line 46 "src/form/binary_other/CopySign.birch"
#line 46 "src/form/binary_other/CopySign.birch"
Real copysign(const Real& l, const Integer& r) {
  #line 47 "src/form/binary_other/CopySign.birch"
  return copysign(l, scalar<Real>(r));
}

}
namespace birch {
#line 1 "src/form/binary_other/Divide.birch"
#line 1 "src/form/binary_other/Divide.birch"
DivideFunction_::DivideFunction_() {
  //
}

#line 43 "src/form/binary_other/Divide.birch"
#line 43 "src/form/binary_other/Divide.birch"
libbirch::DefaultArray<Integer,1> operator/(const libbirch::DefaultArray<Integer,1>& x, const Integer& y) {
  #line 44 "src/form/binary_other/Divide.birch"

  return x.toEigen().operator/(y);
  }

#line 52 "src/form/binary_other/Divide.birch"
#line 52 "src/form/binary_other/Divide.birch"
libbirch::DefaultArray<Real,1> operator/(const libbirch::DefaultArray<Integer,1>& x, const Real& y) {
  #line 53 "src/form/binary_other/Divide.birch"

  return x.toEigen().cast<Real>().operator/(y);
  }

#line 61 "src/form/binary_other/Divide.birch"
#line 61 "src/form/binary_other/Divide.birch"
libbirch::DefaultArray<Real,1> operator/(const libbirch::DefaultArray<Real,1>& x, const Integer& y) {
  #line 62 "src/form/binary_other/Divide.birch"
  return x / scalar<Real>(y);
}

#line 68 "src/form/binary_other/Divide.birch"
#line 68 "src/form/binary_other/Divide.birch"
libbirch::DefaultArray<Real,1> operator/(const libbirch::DefaultArray<Real,1>& x, const Real& y) {
  #line 69 "src/form/binary_other/Divide.birch"

  return x.toEigen().operator/(y);
  }

#line 77 "src/form/binary_other/Divide.birch"
#line 77 "src/form/binary_other/Divide.birch"
libbirch::DefaultArray<Integer,2> operator/(const libbirch::DefaultArray<Integer,2>& x, const Integer& y) {
  #line 78 "src/form/binary_other/Divide.birch"

  return x.toEigen().operator/(y);
  }

#line 86 "src/form/binary_other/Divide.birch"
#line 86 "src/form/binary_other/Divide.birch"
libbirch::DefaultArray<Real,2> operator/(const libbirch::DefaultArray<Integer,2>& x, const Real& y) {
  #line 87 "src/form/binary_other/Divide.birch"

  return x.toEigen().cast<Real>().operator/(y);
  }

#line 95 "src/form/binary_other/Divide.birch"
#line 95 "src/form/binary_other/Divide.birch"
libbirch::DefaultArray<Real,2> operator/(const libbirch::DefaultArray<Real,2>& x, const Integer& y) {
  #line 96 "src/form/binary_other/Divide.birch"
  return x / scalar<Real>(y);
}

#line 102 "src/form/binary_other/Divide.birch"
#line 102 "src/form/binary_other/Divide.birch"
libbirch::DefaultArray<Real,2> operator/(const libbirch::DefaultArray<Real,2>& x, const Real& y) {
  #line 103 "src/form/binary_other/Divide.birch"

  return x.toEigen().operator/(y);
  }

}
namespace birch {
#line 1 "src/form/binary_other/LessThan.birch"
#line 1 "src/form/binary_other/LessThan.birch"
LessThanFunction_::LessThanFunction_() {
  //
}

}
namespace birch {
#line 1 "src/form/binary_other/LogBeta.birch"
#line 1 "src/form/binary_other/LogBeta.birch"
LogBetaFunction_::LogBetaFunction_() {
  //
}

#line 23 "src/form/binary_other/LogBeta.birch"
#line 23 "src/form/binary_other/LogBeta.birch"
Real lbeta(const Integer& l, const Integer& r) {
  #line 24 "src/form/binary_other/LogBeta.birch"
  return lbeta(scalar<Real>(l), scalar<Real>(r));
}

#line 30 "src/form/binary_other/LogBeta.birch"
#line 30 "src/form/binary_other/LogBeta.birch"
Real lbeta(const Real& l, const Real& r) {
  #line 31 "src/form/binary_other/LogBeta.birch"
  return lgamma(l) + lgamma(r) - lgamma(l + r);
}

#line 37 "src/form/binary_other/LogBeta.birch"
#line 37 "src/form/binary_other/LogBeta.birch"
Real lbeta(const Integer& l, const Real& r) {
  #line 38 "src/form/binary_other/LogBeta.birch"
  return lbeta(scalar<Real>(l), r);
}

#line 44 "src/form/binary_other/LogBeta.birch"
#line 44 "src/form/binary_other/LogBeta.birch"
Real lbeta(const Real& l, const Integer& r) {
  #line 45 "src/form/binary_other/LogBeta.birch"
  return lbeta(l, scalar<Real>(r));
}

}
namespace birch {
#line 1 "src/form/binary_other/LogChoose.birch"
#line 1 "src/form/binary_other/LogChoose.birch"
LogChooseFunction_::LogChooseFunction_() {
  //
}

#line 23 "src/form/binary_other/LogChoose.birch"
#line 23 "src/form/binary_other/LogChoose.birch"
Real lchoose(const Integer& x, const Integer& y) {
  #line 24 "src/form/binary_other/LogChoose.birch"
  return lchoose(scalar<Real>(x), scalar<Real>(y));
}

#line 30 "src/form/binary_other/LogChoose.birch"
#line 30 "src/form/binary_other/LogChoose.birch"
Real lchoose(const Real& x, const Real& y) {
  #line 31 "src/form/binary_other/LogChoose.birch"
  if (y == 0.0) {
    #line 32 "src/form/binary_other/LogChoose.birch"
    return 0.0;
  } else {
    #line 35 "src/form/binary_other/LogChoose.birch"
    return -(log(y)) - lbeta(y, x - y + 1.0);
  }
}

#line 42 "src/form/binary_other/LogChoose.birch"
#line 42 "src/form/binary_other/LogChoose.birch"
Real lchoose(const Integer& x, const Real& y) {
  #line 43 "src/form/binary_other/LogChoose.birch"
  return lchoose(scalar<Real>(x), y);
}

#line 49 "src/form/binary_other/LogChoose.birch"
#line 49 "src/form/binary_other/LogChoose.birch"
Real lchoose(const Real& x, const Integer& y) {
  #line 50 "src/form/binary_other/LogChoose.birch"
  return lchoose(x, scalar<Real>(y));
}

}
namespace birch {
#line 1 "src/form/binary_other/LogGammaP.birch"
#line 1 "src/form/binary_other/LogGammaP.birch"
LogGammaPFunction_::LogGammaPFunction_() {
  //
}

#line 27 "src/form/binary_other/LogGammaP.birch"
#line 27 "src/form/binary_other/LogGammaP.birch"
Real lgamma(const Integer& x, const Integer& p) {
  #line 28 "src/form/binary_other/LogGammaP.birch"
  return lgamma(scalar<Real>(x), p);
}

#line 34 "src/form/binary_other/LogGammaP.birch"
#line 34 "src/form/binary_other/LogGammaP.birch"
Real lgamma(const Real& x, const Integer& p) {
  #line 35 "src/form/binary_other/LogGammaP.birch"
  assert(p > Integer(0));
  auto y = 0.25 * (p * (p - Integer(1))) * log(\u03c0);
  #line 37 "src/form/binary_other/LogGammaP.birch"
  for (auto i = Integer(1); i <= p; ++i) {
    #line 38 "src/form/binary_other/LogGammaP.birch"
    y = y + lgamma(x + 0.5 * (Integer(1) - i));
  }
  #line 40 "src/form/binary_other/LogGammaP.birch"
  return y;
}

}
namespace birch {
#line 1 "src/form/binary_other/Multiply.birch"
#line 1 "src/form/binary_other/Multiply.birch"
MultiplyFunction_::MultiplyFunction_() {
  //
}

#line 83 "src/form/binary_other/Multiply.birch"
#line 83 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Integer,1> operator*(const Integer& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 84 "src/form/binary_other/Multiply.birch"

  return y.toEigen().operator*(x);
  }

#line 92 "src/form/binary_other/Multiply.birch"
#line 92 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,1> operator*(const Integer& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 93 "src/form/binary_other/Multiply.birch"
  return scalar<Real>(x) * y;
}

#line 99 "src/form/binary_other/Multiply.birch"
#line 99 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,1> operator*(const Real& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 100 "src/form/binary_other/Multiply.birch"

  return y.toEigen().cast<Real>().operator*(x);
  }

#line 108 "src/form/binary_other/Multiply.birch"
#line 108 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,1> operator*(const Real& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 109 "src/form/binary_other/Multiply.birch"

  return y.toEigen().operator*(x);
  }

#line 117 "src/form/binary_other/Multiply.birch"
#line 117 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Integer,1> operator*(const libbirch::DefaultArray<Integer,1>& x, const Integer& y) {
  #line 118 "src/form/binary_other/Multiply.birch"

  return x.toEigen().operator*(y);
  }

#line 126 "src/form/binary_other/Multiply.birch"
#line 126 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,1> operator*(const libbirch::DefaultArray<Integer,1>& x, const Real& y) {
  #line 127 "src/form/binary_other/Multiply.birch"

  return x.toEigen().cast<Real>().operator*(y);
  }

#line 135 "src/form/binary_other/Multiply.birch"
#line 135 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,1> operator*(const libbirch::DefaultArray<Real,1>& x, const Integer& y) {
  #line 136 "src/form/binary_other/Multiply.birch"
  return x * scalar<Real>(y);
}

#line 142 "src/form/binary_other/Multiply.birch"
#line 142 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,1> operator*(const libbirch::DefaultArray<Real,1>& x, const Real& y) {
  #line 143 "src/form/binary_other/Multiply.birch"

  return x.toEigen().operator*(y);
  }

#line 151 "src/form/binary_other/Multiply.birch"
#line 151 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Integer,1> operator*(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 152 "src/form/binary_other/Multiply.birch"

  return x.toEigen().operator*(y.toEigen());
  }

#line 160 "src/form/binary_other/Multiply.birch"
#line 160 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,1> operator*(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 161 "src/form/binary_other/Multiply.birch"

  return x.toEigen().cast<Real>().operator*(y.toEigen());
  }

#line 169 "src/form/binary_other/Multiply.birch"
#line 169 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,1> operator*(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 170 "src/form/binary_other/Multiply.birch"

  return x.toEigen().operator*(y.toEigen().cast<Real>());
  }

#line 178 "src/form/binary_other/Multiply.birch"
#line 178 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,1> operator*(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 179 "src/form/binary_other/Multiply.birch"

  return x.toEigen().operator*(y.toEigen());
  }

#line 187 "src/form/binary_other/Multiply.birch"
#line 187 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Integer,2> operator*(const Integer& x, const libbirch::DefaultArray<Integer,2>& y) {
  #line 188 "src/form/binary_other/Multiply.birch"

  return y.toEigen().operator*(x);
  }

#line 196 "src/form/binary_other/Multiply.birch"
#line 196 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,2> operator*(const Integer& x, const libbirch::DefaultArray<Real,2>& y) {
  #line 197 "src/form/binary_other/Multiply.birch"
  return scalar<Real>(x) * y;
}

#line 203 "src/form/binary_other/Multiply.birch"
#line 203 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,2> operator*(const Real& x, const libbirch::DefaultArray<Integer,2>& y) {
  #line 204 "src/form/binary_other/Multiply.birch"

  return y.toEigen().cast<Real>().operator*(x);
  }

#line 212 "src/form/binary_other/Multiply.birch"
#line 212 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,2> operator*(const Real& x, const libbirch::DefaultArray<Real,2>& y) {
  #line 213 "src/form/binary_other/Multiply.birch"

  return y.toEigen().operator*(x);
  }

#line 221 "src/form/binary_other/Multiply.birch"
#line 221 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Integer,2> operator*(const libbirch::DefaultArray<Integer,2>& x, const Integer& y) {
  #line 222 "src/form/binary_other/Multiply.birch"

  return x.toEigen().operator*(y);
  }

#line 230 "src/form/binary_other/Multiply.birch"
#line 230 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,2> operator*(const libbirch::DefaultArray<Integer,2>& x, const Real& y) {
  #line 231 "src/form/binary_other/Multiply.birch"

  return x.toEigen().cast<Real>().operator*(y);
  }

#line 239 "src/form/binary_other/Multiply.birch"
#line 239 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,2> operator*(const libbirch::DefaultArray<Real,2>& x, const Integer& y) {
  #line 240 "src/form/binary_other/Multiply.birch"
  return x * scalar<Real>(y);
}

#line 246 "src/form/binary_other/Multiply.birch"
#line 246 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,2> operator*(const libbirch::DefaultArray<Real,2>& x, const Real& y) {
  #line 247 "src/form/binary_other/Multiply.birch"

  return x.toEigen().operator*(y);
  }

#line 255 "src/form/binary_other/Multiply.birch"
#line 255 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Integer,1> operator*(const libbirch::DefaultArray<Integer,2>& X, const libbirch::DefaultArray<Integer,1>& y) {
  #line 256 "src/form/binary_other/Multiply.birch"

  return X.toEigen().operator*(y.toEigen());
  }

#line 264 "src/form/binary_other/Multiply.birch"
#line 264 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,1> operator*(const libbirch::DefaultArray<Integer,2>& X, const libbirch::DefaultArray<Real,1>& y) {
  #line 265 "src/form/binary_other/Multiply.birch"

  return X.toEigen().cast<Real>().operator*(y.toEigen());
  }

#line 273 "src/form/binary_other/Multiply.birch"
#line 273 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,1> operator*(const libbirch::DefaultArray<Real,2>& X, const libbirch::DefaultArray<Integer,1>& y) {
  #line 274 "src/form/binary_other/Multiply.birch"

  return X.toEigen().operator*(y.toEigen().cast<Real>());
  }

#line 282 "src/form/binary_other/Multiply.birch"
#line 282 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,1> operator*(const libbirch::DefaultArray<Real,2>& X, const libbirch::DefaultArray<Real,1>& y) {
  #line 283 "src/form/binary_other/Multiply.birch"

  return X.toEigen().operator*(y.toEigen());
  }

#line 291 "src/form/binary_other/Multiply.birch"
#line 291 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Integer,2> operator*(const libbirch::DefaultArray<Integer,1>& X, const libbirch::DefaultArray<Integer,2>& y) {
  #line 292 "src/form/binary_other/Multiply.birch"

  return X.toEigen().operator*(y.toEigen());
  }

#line 300 "src/form/binary_other/Multiply.birch"
#line 300 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,2> operator*(const libbirch::DefaultArray<Integer,1>& X, const libbirch::DefaultArray<Real,2>& y) {
  #line 301 "src/form/binary_other/Multiply.birch"

  return X.toEigen().cast<Real>().operator*(y.toEigen());
  }

#line 309 "src/form/binary_other/Multiply.birch"
#line 309 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,2> operator*(const libbirch::DefaultArray<Real,1>& X, const libbirch::DefaultArray<Integer,2>& y) {
  #line 310 "src/form/binary_other/Multiply.birch"

  return X.toEigen().operator*(y.toEigen().cast<Real>());
  }

#line 318 "src/form/binary_other/Multiply.birch"
#line 318 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,2> operator*(const libbirch::DefaultArray<Real,1>& X, const libbirch::DefaultArray<Real,2>& y) {
  #line 319 "src/form/binary_other/Multiply.birch"

  return X.toEigen().operator*(y.toEigen());
  }

#line 327 "src/form/binary_other/Multiply.birch"
#line 327 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Integer,2> operator*(const libbirch::DefaultArray<Integer,2>& X, const libbirch::DefaultArray<Integer,2>& Y) {
  #line 328 "src/form/binary_other/Multiply.birch"

  return X.toEigen().operator*(Y.toEigen());
  }

#line 336 "src/form/binary_other/Multiply.birch"
#line 336 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,2> operator*(const libbirch::DefaultArray<Integer,2>& X, const libbirch::DefaultArray<Real,2>& Y) {
  #line 337 "src/form/binary_other/Multiply.birch"

  return X.toEigen().cast<Real>().operator*(Y.toEigen());
  }

#line 345 "src/form/binary_other/Multiply.birch"
#line 345 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,2> operator*(const libbirch::DefaultArray<Real,2>& X, const libbirch::DefaultArray<Integer,2>& Y) {
  #line 346 "src/form/binary_other/Multiply.birch"

  return X.toEigen().operator*(Y.toEigen().cast<Real>());
  }

#line 354 "src/form/binary_other/Multiply.birch"
#line 354 "src/form/binary_other/Multiply.birch"
libbirch::DefaultArray<Real,2> operator*(const libbirch::DefaultArray<Real,2>& X, const libbirch::DefaultArray<Real,2>& Y) {
  #line 355 "src/form/binary_other/Multiply.birch"

  return X.toEigen().operator*(Y.toEigen());
  }

}
namespace birch {
#line 1 "src/form/binary_other/Pow.birch"
#line 1 "src/form/binary_other/Pow.birch"
PowFunction_::PowFunction_() {
  //
}

#line 28 "src/form/binary_other/Pow.birch"
#line 28 "src/form/binary_other/Pow.birch"
Integer pow(const Integer& x, const Integer& y) {
  #line 29 "src/form/binary_other/Pow.birch"

  return std::pow(x, y);
  }

#line 37 "src/form/binary_other/Pow.birch"
#line 37 "src/form/binary_other/Pow.birch"
Real pow(const Real& x, const Real& y) {
  #line 38 "src/form/binary_other/Pow.birch"

  return std::pow(x, y);
  }

#line 46 "src/form/binary_other/Pow.birch"
#line 46 "src/form/binary_other/Pow.birch"
Real pow(const Integer& x, const Real& y) {
  #line 47 "src/form/binary_other/Pow.birch"
  return pow(scalar<Real>(x), y);
}

#line 53 "src/form/binary_other/Pow.birch"
#line 53 "src/form/binary_other/Pow.birch"
Real pow(const Real& x, const Integer& y) {
  #line 54 "src/form/binary_other/Pow.birch"
  return pow(x, scalar<Real>(y));
}

}
namespace birch {
#line 1 "src/form/binary_other/Subtract.birch"
#line 1 "src/form/binary_other/Subtract.birch"
SubtractFunction_::SubtractFunction_() {
  //
}

#line 42 "src/form/binary_other/Subtract.birch"
#line 42 "src/form/binary_other/Subtract.birch"
libbirch::DefaultArray<Integer,1> operator-(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 43 "src/form/binary_other/Subtract.birch"

  return x.toEigen().operator-(y.toEigen());
  }

#line 51 "src/form/binary_other/Subtract.birch"
#line 51 "src/form/binary_other/Subtract.birch"
libbirch::DefaultArray<Real,1> operator-(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 52 "src/form/binary_other/Subtract.birch"

  return x.toEigen().cast<Real>().operator-(y.toEigen());
  }

#line 60 "src/form/binary_other/Subtract.birch"
#line 60 "src/form/binary_other/Subtract.birch"
libbirch::DefaultArray<Real,1> operator-(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 61 "src/form/binary_other/Subtract.birch"

  return x.toEigen().operator-(y.toEigen().cast<Real>());
  }

#line 69 "src/form/binary_other/Subtract.birch"
#line 69 "src/form/binary_other/Subtract.birch"
libbirch::DefaultArray<Real,1> operator-(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 70 "src/form/binary_other/Subtract.birch"

  return x.toEigen().operator-(y.toEigen());
  }

#line 78 "src/form/binary_other/Subtract.birch"
#line 78 "src/form/binary_other/Subtract.birch"
libbirch::DefaultArray<Integer,2> operator-(const libbirch::DefaultArray<Integer,2>& x, const libbirch::DefaultArray<Integer,2>& y) {
  #line 79 "src/form/binary_other/Subtract.birch"

  return x.toEigen().operator-(y.toEigen());
  }

#line 87 "src/form/binary_other/Subtract.birch"
#line 87 "src/form/binary_other/Subtract.birch"
libbirch::DefaultArray<Real,2> operator-(const libbirch::DefaultArray<Integer,2>& x, const libbirch::DefaultArray<Real,2>& y) {
  #line 88 "src/form/binary_other/Subtract.birch"

  return x.toEigen().cast<Real>().operator-(y.toEigen());
  }

#line 96 "src/form/binary_other/Subtract.birch"
#line 96 "src/form/binary_other/Subtract.birch"
libbirch::DefaultArray<Real,2> operator-(const libbirch::DefaultArray<Real,2>& x, const libbirch::DefaultArray<Integer,2>& y) {
  #line 97 "src/form/binary_other/Subtract.birch"

  return x.toEigen().operator-(y.toEigen().cast<Real>());
  }

#line 105 "src/form/binary_other/Subtract.birch"
#line 105 "src/form/binary_other/Subtract.birch"
libbirch::DefaultArray<Real,2> operator-(const libbirch::DefaultArray<Real,2>& x, const libbirch::DefaultArray<Real,2>& y) {
  #line 106 "src/form/binary_other/Subtract.birch"

  return x.toEigen().operator-(y.toEigen());
  }

}
