namespace birch {
#line 1 "src/form/ternary/IfThenElse.birch"
#line 1 "src/form/ternary/IfThenElse.birch"
IfThenElseFunction_::IfThenElseFunction_() {
  //
}

}
namespace birch {
#line 1 "src/form/ternary/LogZConwayMaxwellPoisson.birch"
#line 1 "src/form/ternary/LogZConwayMaxwellPoisson.birch"
LogZConwayMaxwellPoissonFunction_::LogZConwayMaxwellPoissonFunction_() {
  //
}

#line 43 "src/form/ternary/LogZConwayMaxwellPoisson.birch"
#line 43 "src/form/ternary/LogZConwayMaxwellPoisson.birch"
Real logz_conway_maxwell_poisson(const Real& \u03bb, const Real& \u03bd, const Integer& n) {
  auto log_\u03bb = log(\u03bb);
  auto z = vector_lambda([=](const Integer& x) {
    #line 46 "src/form/ternary/LogZConwayMaxwellPoisson.birch"
    return if_then_else(x == Integer(1), 0.0, (x - Integer(1)) * log_\u03bb - \u03bd * lgamma(x));
  }, n + Integer(1));
  #line 48 "src/form/ternary/LogZConwayMaxwellPoisson.birch"
  return log_sum_exp(z);
}

}
