namespace birch {
#line 7 "src/iterator/ArrayBufferIterator.birch"
#line 7 "src/iterator/ArrayBufferIterator.birch"
ArrayBufferIterator_::ArrayBufferIterator_(const libbirch::DefaultArray<Buffer,1>& values) :
    #line 7 "src/iterator/ArrayBufferIterator.birch"
    base_type_(),
    #line 11 "src/iterator/ArrayBufferIterator.birch"
    values(values),
    #line 16 "src/iterator/ArrayBufferIterator.birch"
    i(Integer(0)) {
  //
}

#line 21 "src/iterator/ArrayBufferIterator.birch"
#line 21 "src/iterator/ArrayBufferIterator.birch"
#line 21 "src/iterator/ArrayBufferIterator.birch"
Boolean ArrayBufferIterator_::hasNext() {
  #line 22 "src/iterator/ArrayBufferIterator.birch"
  return i < length(values);
}

#line 28 "src/iterator/ArrayBufferIterator.birch"
#line 28 "src/iterator/ArrayBufferIterator.birch"
#line 28 "src/iterator/ArrayBufferIterator.birch"
Buffer ArrayBufferIterator_::next() {
  #line 29 "src/iterator/ArrayBufferIterator.birch"
  i = i + Integer(1);
  #line 30 "src/iterator/ArrayBufferIterator.birch"
  return values(i);
}

}
namespace birch {
}
namespace birch {
}
namespace birch {
}
namespace birch {
}
namespace birch {
}
namespace birch {
#line 8 "src/iterator/ObjectBufferIterator.birch"
#line 8 "src/iterator/ObjectBufferIterator.birch"
ObjectBufferIterator_::ObjectBufferIterator_(const libbirch::DefaultArray<String,1>& keys, const libbirch::DefaultArray<Buffer,1>& values) :
    #line 8 "src/iterator/ObjectBufferIterator.birch"
    base_type_(),
    #line 13 "src/iterator/ObjectBufferIterator.birch"
    keys(keys),
    #line 18 "src/iterator/ObjectBufferIterator.birch"
    values(values) {
  //
}

#line 23 "src/iterator/ObjectBufferIterator.birch"
#line 23 "src/iterator/ObjectBufferIterator.birch"
#line 23 "src/iterator/ObjectBufferIterator.birch"
Boolean ObjectBufferIterator_::hasNext() {
  #line 24 "src/iterator/ObjectBufferIterator.birch"
  return keys.has_value() && values.has_value();
}

#line 30 "src/iterator/ObjectBufferIterator.birch"
#line 30 "src/iterator/ObjectBufferIterator.birch"
#line 30 "src/iterator/ObjectBufferIterator.birch"
Buffer ObjectBufferIterator_::next() {
  auto buffer = make_buffer(keys.value(), values.value());
  #line 32 "src/iterator/ObjectBufferIterator.birch"
  keys = std::nullopt;
  #line 33 "src/iterator/ObjectBufferIterator.birch"
  values = std::nullopt;
  #line 34 "src/iterator/ObjectBufferIterator.birch"
  return buffer;
}

}
namespace birch {
}
namespace birch {
}
namespace birch {
}
namespace birch {
}
namespace birch {
}
namespace birch {
}
