namespace birch {
#line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
TestFanMatrixNormalInverseWishartMatrixGaussian_::TestFanMatrixNormalInverseWishartMatrixGaussian_() :
    #line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    \u03a3(),
    #line 3 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    X(),
    #line 4 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    Y1(),
    #line 5 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    Y2(),
    #line 6 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    Y3(),
    #line 7 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    Y4(),
    #line 8 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    Y5(),
    #line 10 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    n(Integer(5)),
    #line 11 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    p(Integer(4)),
    #line 13 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    k(),
    #line 14 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    \u03a8((libbirch::make_shape(p, p))),
    #line 15 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    M((libbirch::make_shape(n, p))),
    #line 16 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    U((libbirch::make_shape(n, n))),
    #line 17 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    V((libbirch::make_shape(n, n))) {
  //
}

#line 19 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 19 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 19 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
void TestFanMatrixNormalInverseWishartMatrixGaussian_::initialize() {
  #line 20 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  k = simulate_uniform(2.0, 10.0);
  #line 21 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  \u03a8 = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 21 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, p, p);
  #line 22 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  M = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 22 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(10.0), 10.0);
  }, n, p);
  #line 23 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  U = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 23 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, n, n);
  #line 24 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  V = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 24 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, n, n);
  #line 26 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  \u03a8 = outer(\u03a8) + diagonal(1.0e-2, p);
  #line 27 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  U = outer(U) + diagonal(1.0e-2, n);
  #line 28 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  V = outer(V) + diagonal(1.0e-2, n);
}

#line 31 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 31 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 31 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
void TestFanMatrixNormalInverseWishartMatrixGaussian_::simulate() {
  #line 32 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(\u03a3, InverseWishart(\u03a8, k));
;
  #line 33 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(X, MatrixGaussian(M, U, \u03a3));
;
  #line 34 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(Y1, MatrixGaussian(X, V, \u03a3));
;
  #line 35 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(Y2, MatrixGaussian(X, V, \u03a3));
;
  #line 36 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(Y3, MatrixGaussian(X, V, \u03a3));
;
  #line 37 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(Y4, MatrixGaussian(X, V, \u03a3));
;
  #line 38 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(Y5, MatrixGaussian(X, V, \u03a3));
;
}

#line 41 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 41 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 41 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
libbirch::DefaultArray<Real,1> TestFanMatrixNormalInverseWishartMatrixGaussian_::forward() {
  #line 42 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  \u03a3->eval();
  #line 43 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  X->eval();
  #line 44 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y1->eval();
  #line 45 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y2->eval();
  #line 46 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y3->eval();
  #line 47 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y4->eval();
  #line 48 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y5->eval();
  #line 49 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  return vectorize();
}

#line 52 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 52 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 52 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
libbirch::DefaultArray<Real,1> TestFanMatrixNormalInverseWishartMatrixGaussian_::backward() {
  #line 53 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(Y5->hasValue()));
  #line 54 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y5->eval();
  #line 55 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y4->eval();
  #line 56 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y3->eval();
  #line 57 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y2->eval();
  #line 58 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y1->eval();
  #line 59 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(X->hasValue()));
  #line 60 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  X->eval();
  #line 61 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(\u03a3->hasValue()));
  #line 62 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  \u03a3->eval();
  #line 63 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  return vectorize();
}

#line 66 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 66 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 66 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
void TestFanMatrixNormalInverseWishartMatrixGaussian_::backwardGrad() {
  #line 67 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(Y5->hasValue()));
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y5->eval();
  #line 69 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y4->eval();
  #line 70 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y3->eval();
  #line 71 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y2->eval();
  #line 72 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Y1->eval();
  #line 73 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(X->hasValue()));
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  X->eval();
  #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(\u03a3->hasValue()));
}

#line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
Distribution<libbirch::DefaultArray<Real,2>> TestFanMatrixNormalInverseWishartMatrixGaussian_::marginal() {
  #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  return Y5->getDistribution();
}

#line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
libbirch::DefaultArray<Real,1> TestFanMatrixNormalInverseWishartMatrixGaussian_::vectorize() {
  libbirch::DefaultArray<Real,1> z(libbirch::make_shape(size()));
  auto k = Integer(0);
  #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + p * p)) = vec(\u03a3->eval());
  #line 88 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  k = k + p * p;
  #line 89 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + n * p)) = vec(X->eval());
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  k = k + n * p;
  #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + n * p)) = vec(Y1->eval());
  #line 92 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  k = k + n * p;
  #line 93 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + n * p)) = vec(Y2->eval());
  #line 94 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  k = k + n * p;
  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + n * p)) = vec(Y3->eval());
  #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  k = k + n * p;
  #line 97 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + n * p)) = vec(Y4->eval());
  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  k = k + n * p;
  #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + n * p)) = vec(Y5->eval());
  #line 100 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  return z;
}

#line 103 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 103 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
#line 103 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
Integer TestFanMatrixNormalInverseWishartMatrixGaussian_::size() {
  #line 104 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  return p * p + Integer(6) * n * p;
}

#line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
TestFanMatrixNormalInverseWishartMatrixGaussian_* make_TestFanMatrixNormalInverseWishartMatrixGaussian_() {
  #line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  return new TestFanMatrixNormalInverseWishartMatrixGaussian_();
  #line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
}

#line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
int test_conjugacy_fan_matrix_normal_inverse_wishart_matrix_gaussian(int argc_, char** argv_) {
  #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  int c_, option_index_;
  #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  option long_options_[] = {
    #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    {0, 0, 0, 0}
  #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  };
  #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  const char* short_options_ = ":";
  #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  ::opterr = 0;
  #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  while (c_ != -1) {
    #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    switch (c_) {
      #line 109 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case NFLAG_:
        #line 109 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 109 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 109 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 109 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 109 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 109 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case lazyFLAG_:
        #line 109 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 109 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 109 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 109 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 109 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case '?':
        #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case ':':
        #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      default:
        #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Eigen::initParallel();

  {
    TestFanMatrixNormalInverseWishartMatrixGaussian m;
    #line 111 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  libbirch::collect();
  #line 108 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  return 0;
}

#line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
int test_pdf_fan_matrix_normal_inverse_wishart_matrix_gaussian(int argc_, char** argv_) {
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer B = Integer(1000);
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer S = Integer(20);
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  int c_, option_index_;
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  option long_options_[] = {
    #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    {0, 0, 0, 0}
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  };
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  const char* short_options_ = ":";
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  ::opterr = 0;
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  while (c_ != -1) {
    #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    switch (c_) {
      #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case NFLAG_:
        #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case BFLAG_:
        #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case SFLAG_:
        #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 115 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 116 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case lazyFLAG_:
        #line 116 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 116 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 116 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 116 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 116 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case '?':
        #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case ':':
        #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      default:
        #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Eigen::initParallel();

  {
    TestFanMatrixNormalInverseWishartMatrixGaussian m;
    #line 118 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    m->initialize();
    #line 119 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    m->simulate();
    #line 120 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  libbirch::collect();
  #line 114 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  return 0;
}

#line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
int test_grad_fan_matrix_normal_inverse_wishart_matrix_gaussian(int argc_, char** argv_) {
  #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  int c_, option_index_;
  #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  option long_options_[] = {
    #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    {0, 0, 0, 0}
  #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  };
  #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  const char* short_options_ = ":";
  #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  ::opterr = 0;
  #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  while (c_ != -1) {
    #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    switch (c_) {
      #line 124 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case NFLAG_:
        #line 124 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 124 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 124 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 124 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 124 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 124 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case backwardFLAG_:
        #line 124 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 124 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 124 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 124 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 124 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case '?':
        #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      case ':':
        #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      default:
        #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  Eigen::initParallel();

  {
    TestFanMatrixNormalInverseWishartMatrixGaussian m;
    #line 126 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    if (!(backward)) {
      #line 127 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
      warn(String("forward order not supported, switching to backward order"));
    }
    #line 129 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
    test_grad(m, N, true);
  }
  #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  libbirch::collect();
  #line 123 "src/test/distribution/matrix_normal_inverse_wishart/TestFanMatrixNormalInverseWishartMatrixGaussian.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
TestLinearMatrixNormalInverseWishartMatrixGaussian_::TestLinearMatrixNormalInverseWishartMatrixGaussian_() :
    #line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    \u03a3(),
    #line 3 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    X(),
    #line 4 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    Y(),
    #line 6 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    n(Integer(5)),
    #line 7 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    p(Integer(4)),
    #line 9 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    k(),
    #line 10 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    \u03a8((libbirch::make_shape(p, p))),
    #line 11 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    A((libbirch::make_shape(n, n))),
    #line 12 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    M((libbirch::make_shape(n, p))),
    #line 13 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    C((libbirch::make_shape(n, p))),
    #line 14 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    U((libbirch::make_shape(n, n))),
    #line 15 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    V((libbirch::make_shape(n, n))) {
  //
}

#line 17 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 17 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 17 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
void TestLinearMatrixNormalInverseWishartMatrixGaussian_::initialize() {
  #line 18 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  k = simulate_uniform(2.0, 10.0);
  #line 19 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  \u03a8 = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 19 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, p, p);
  #line 20 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  A = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 20 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, n, n);
  #line 21 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  M = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 21 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(10.0), 10.0);
  }, n, p);
  #line 22 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  C = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 22 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(10.0), 10.0);
  }, n, p);
  #line 23 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  U = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 23 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, n, n);
  #line 24 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  V = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 24 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, n, n);
  #line 26 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  \u03a8 = outer(\u03a8) + diagonal(1.0e-2, p);
  #line 27 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  U = outer(U) + diagonal(1.0e-2, n);
  #line 28 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  V = outer(V) + diagonal(1.0e-2, n);
}

#line 31 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 31 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 31 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
void TestLinearMatrixNormalInverseWishartMatrixGaussian_::simulate() {
  #line 32 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(\u03a3, InverseWishart(\u03a8, k));
;
  #line 33 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(X, MatrixGaussian(M, U, \u03a3));
;
  #line 34 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(Y, MatrixGaussian(A * X + C, V, \u03a3));
;
}

#line 37 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 37 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 37 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
libbirch::DefaultArray<Real,1> TestLinearMatrixNormalInverseWishartMatrixGaussian_::forward() {
  #line 38 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  \u03a3->eval();
  #line 39 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  X->eval();
  #line 40 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  Y->eval();
  #line 41 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  return vectorize();
}

#line 44 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 44 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 44 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
libbirch::DefaultArray<Real,1> TestLinearMatrixNormalInverseWishartMatrixGaussian_::backward() {
  #line 45 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(Y->hasValue()));
  #line 46 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  Y->eval();
  #line 47 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(X->hasValue()));
  #line 48 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  X->eval();
  #line 49 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(\u03a3->hasValue()));
  #line 50 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  \u03a3->eval();
  #line 51 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  return vectorize();
}

#line 54 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 54 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 54 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
void TestLinearMatrixNormalInverseWishartMatrixGaussian_::backwardGrad() {
  #line 55 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(Y->hasValue()));
  #line 56 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  Y->eval();
  #line 57 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(X->hasValue()));
  #line 58 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  X->eval();
  #line 59 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(\u03a3->hasValue()));
}

#line 64 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 64 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 64 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
Distribution<libbirch::DefaultArray<Real,2>> TestLinearMatrixNormalInverseWishartMatrixGaussian_::marginal() {
  #line 65 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  return Y->getDistribution();
}

#line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
libbirch::DefaultArray<Real,1> TestLinearMatrixNormalInverseWishartMatrixGaussian_::vectorize() {
  libbirch::DefaultArray<Real,1> z(libbirch::make_shape(size()));
  auto k = Integer(0);
  #line 71 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + p * p)) = vec(\u03a3->eval());
  #line 72 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  k = k + p * p;
  #line 73 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + n * p)) = vec(X->eval());
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  k = k + n * p;
  #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + n * p)) = vec(Y->eval());
  #line 76 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  return z;
}

#line 79 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 79 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
#line 79 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
Integer TestLinearMatrixNormalInverseWishartMatrixGaussian_::size() {
  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  return p * p + Integer(2) * n * p;
}

#line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
TestLinearMatrixNormalInverseWishartMatrixGaussian_* make_TestLinearMatrixNormalInverseWishartMatrixGaussian_() {
  #line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  return new TestLinearMatrixNormalInverseWishartMatrixGaussian_();
  #line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
}

#line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
int test_conjugacy_linear_matrix_normal_inverse_wishart_matrix_gaussian(int argc_, char** argv_) {
  #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  int c_, option_index_;
  #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  option long_options_[] = {
    #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    {0, 0, 0, 0}
  #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  };
  #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  const char* short_options_ = ":";
  #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  ::opterr = 0;
  #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  while (c_ != -1) {
    #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    switch (c_) {
      #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case NFLAG_:
        #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case lazyFLAG_:
        #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case '?':
        #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case ':':
        #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      default:
        #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMatrixNormalInverseWishartMatrixGaussian m;
    #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  libbirch::collect();
  #line 84 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  return 0;
}

#line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
int test_pdf_linear_matrix_normal_inverse_wishart_matrix_gaussian(int argc_, char** argv_) {
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer B = Integer(1000);
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer S = Integer(20);
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  int c_, option_index_;
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  option long_options_[] = {
    #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    {0, 0, 0, 0}
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  };
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  const char* short_options_ = ":";
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  ::opterr = 0;
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  while (c_ != -1) {
    #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    switch (c_) {
      #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case NFLAG_:
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case BFLAG_:
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case SFLAG_:
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case lazyFLAG_:
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case '?':
        #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case ':':
        #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      default:
        #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMatrixNormalInverseWishartMatrixGaussian m;
    #line 93 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    m->initialize();
    #line 94 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    m->simulate();
    #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  libbirch::collect();
  #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  return 0;
}

#line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
int test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian(int argc_, char** argv_) {
  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  int c_, option_index_;
  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  option long_options_[] = {
    #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    {0, 0, 0, 0}
  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  };
  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  const char* short_options_ = ":";
  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  ::opterr = 0;
  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  while (c_ != -1) {
    #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    switch (c_) {
      #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case NFLAG_:
        #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case backwardFLAG_:
        #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case '?':
        #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      case ':':
        #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      default:
        #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMatrixNormalInverseWishartMatrixGaussian m;
    #line 101 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    if (!(backward)) {
      #line 102 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
      warn(String("forward order not supported, switching to backward order"));
    }
    #line 104 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
    test_grad(m, N, true);
  }
  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  libbirch::collect();
  #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
TestMatrixNormalInverseWishart_::TestMatrixNormalInverseWishart_() :
    #line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    base_type_(),
    #line 2 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    \u03a3(),
    #line 3 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    X(),
    #line 5 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    n(Integer(5)),
    #line 6 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    p(Integer(4)),
    #line 8 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    \u03a8((libbirch::make_shape(p, p))),
    #line 9 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    k(),
    #line 10 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    M((libbirch::make_shape(n, p))),
    #line 11 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    U((libbirch::make_shape(n, n))) {
  //
}

#line 13 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 13 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 13 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
void TestMatrixNormalInverseWishart_::initialize() {
  #line 14 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  \u03a8 = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 14 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, p, p);
  #line 15 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  k = simulate_uniform(2.0, 10.0);
  #line 16 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  M = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 16 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    return simulate_uniform(-(10.0), 10.0);
  }, n, p);
  #line 17 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  U = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 17 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, n, n);
  #line 19 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  \u03a8 = outer(\u03a8) + diagonal(1.0e-2, p);
  #line 20 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  U = outer(U) + diagonal(1.0e-2, n);
}

#line 23 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 23 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 23 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
void TestMatrixNormalInverseWishart_::simulate() {
  #line 24 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    handle_assume(\u03a3, InverseWishart(\u03a8, k));
;
  #line 25 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    handle_assume(X, MatrixGaussian(M, U, \u03a3));
;
}

#line 28 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 28 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 28 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
libbirch::DefaultArray<Real,1> TestMatrixNormalInverseWishart_::forward() {
  #line 29 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  \u03a3->eval();
  #line 30 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  X->eval();
  #line 31 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  return vectorize();
}

#line 34 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 34 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 34 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
libbirch::DefaultArray<Real,1> TestMatrixNormalInverseWishart_::backward() {
  #line 35 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  assert(!(X->hasValue()));
  #line 36 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  X->eval();
  #line 37 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  assert(!(\u03a3->hasValue()));
  #line 38 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  \u03a3->eval();
  #line 39 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  return vectorize();
}

#line 42 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 42 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 42 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
void TestMatrixNormalInverseWishart_::backwardGrad() {
  #line 43 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  assert(!(X->hasValue()));
  #line 44 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  X->eval();
  #line 45 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  assert(!(\u03a3->hasValue()));
}

#line 50 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 50 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 50 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
Distribution<libbirch::DefaultArray<Real,2>> TestMatrixNormalInverseWishart_::marginal() {
  #line 51 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  return X->getDistribution();
}

#line 54 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 54 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 54 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
libbirch::DefaultArray<Real,1> TestMatrixNormalInverseWishart_::vectorize() {
  libbirch::DefaultArray<Real,1> z(libbirch::make_shape(size()));
  auto k = Integer(0);
  #line 57 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  z(libbirch::make_range(k + Integer(1), k + p * p)) = vec(\u03a3->eval());
  #line 58 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  k = k + p * p;
  #line 59 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  z(libbirch::make_range(k + Integer(1), k + n * p)) = vec(X->eval());
  #line 60 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  return z;
}

#line 63 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 63 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
#line 63 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
Integer TestMatrixNormalInverseWishart_::size() {
  #line 64 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  return p * p + n * p;
}

#line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
TestMatrixNormalInverseWishart_* make_TestMatrixNormalInverseWishart_() {
  #line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  return new TestMatrixNormalInverseWishart_();
  #line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
}

#line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
int test_conjugacy_matrix_normal_inverse_wishart(int argc_, char** argv_) {
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  int c_, option_index_;
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  option long_options_[] = {
    #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    {0, 0, 0, 0}
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  };
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  const char* short_options_ = ":";
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  ::opterr = 0;
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  while (c_ != -1) {
    #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    switch (c_) {
      #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case NFLAG_:
        #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        if (!::optarg) {
          #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        }
        #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        N = from_string<Integer>(String(::optarg));
        #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        break;
      #line 69 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case lazyFLAG_:
        #line 69 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        if (!::optarg) {
          #line 69 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 69 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        }
        #line 69 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 69 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        break;
      #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case '?':
        #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case ':':
        #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      default:
        #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  Eigen::initParallel();

  {
    TestMatrixNormalInverseWishart m;
    #line 71 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  libbirch::collect();
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  return 0;
}

#line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
int test_pdf_matrix_normal_inverse_wishart(int argc_, char** argv_) {
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  [[maybe_unused]] Integer B = Integer(1000);
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  [[maybe_unused]] Integer S = Integer(20);
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  int c_, option_index_;
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  option long_options_[] = {
    #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    {0, 0, 0, 0}
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  };
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  const char* short_options_ = ":";
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  ::opterr = 0;
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  while (c_ != -1) {
    #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    switch (c_) {
      #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case NFLAG_:
        #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        if (!::optarg) {
          #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        }
        #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        N = from_string<Integer>(String(::optarg));
        #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        break;
      #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case BFLAG_:
        #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        if (!::optarg) {
          #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        }
        #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        B = from_string<Integer>(String(::optarg));
        #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        break;
      #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case SFLAG_:
        #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        if (!::optarg) {
          #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        }
        #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        S = from_string<Integer>(String(::optarg));
        #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        break;
      #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case lazyFLAG_:
        #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        if (!::optarg) {
          #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        }
        #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        break;
      #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case '?':
        #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case ':':
        #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      default:
        #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  Eigen::initParallel();

  {
    TestMatrixNormalInverseWishart m;
    #line 77 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    m->initialize();
    #line 78 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    m->simulate();
    #line 79 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  libbirch::collect();
  #line 74 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  return 0;
}

#line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
int test_grad_matrix_normal_inverse_wishart(int argc_, char** argv_) {
  #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  int c_, option_index_;
  #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  option long_options_[] = {
    #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    {0, 0, 0, 0}
  #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  };
  #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  const char* short_options_ = ":";
  #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  ::opterr = 0;
  #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  while (c_ != -1) {
    #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    switch (c_) {
      #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case NFLAG_:
        #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        if (!::optarg) {
          #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        }
        #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        N = from_string<Integer>(String(::optarg));
        #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        break;
      #line 83 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case backwardFLAG_:
        #line 83 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        if (!::optarg) {
          #line 83 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 83 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        }
        #line 83 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 83 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        break;
      #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case '?':
        #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      case ':':
        #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      default:
        #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  Eigen::initParallel();

  {
    TestMatrixNormalInverseWishart m;
    #line 85 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    if (!(backward)) {
      #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
      warn(String("forward order not supported, switching to backward order"));
    }
    #line 88 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
    test_grad(m, N, true);
  }
  #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  libbirch::collect();
  #line 82 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishart.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
TestMatrixNormalInverseWishartMatrixGaussian_::TestMatrixNormalInverseWishartMatrixGaussian_() :
    #line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    \u03a3(),
    #line 3 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    X(),
    #line 4 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    Y(),
    #line 6 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    n(Integer(5)),
    #line 7 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    p(Integer(4)),
    #line 9 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    k(),
    #line 10 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    \u03a8((libbirch::make_shape(p, p))),
    #line 11 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    M((libbirch::make_shape(n, p))),
    #line 12 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    U((libbirch::make_shape(n, n))),
    #line 13 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    V((libbirch::make_shape(n, n))) {
  //
}

#line 15 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 15 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 15 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
void TestMatrixNormalInverseWishartMatrixGaussian_::initialize() {
  #line 16 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  k = simulate_uniform(2.0, 10.0);
  #line 17 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  \u03a8 = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 17 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, p, p);
  #line 18 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  M = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 18 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(10.0), 10.0);
  }, n, p);
  #line 19 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  U = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 19 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, n, n);
  #line 20 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  V = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 20 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, n, n);
  #line 22 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  \u03a8 = outer(\u03a8) + diagonal(1.0e-2, p);
  #line 23 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  U = outer(U) + diagonal(1.0e-2, n);
  #line 24 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  V = outer(V) + diagonal(1.0e-2, n);
}

#line 27 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 27 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 27 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
void TestMatrixNormalInverseWishartMatrixGaussian_::simulate() {
  #line 28 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(\u03a3, InverseWishart(\u03a8, k));
;
  #line 29 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(X, MatrixGaussian(M, U, \u03a3));
;
  #line 30 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    handle_assume(Y, MatrixGaussian(X, V, \u03a3));
;
}

#line 33 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 33 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 33 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
libbirch::DefaultArray<Real,1> TestMatrixNormalInverseWishartMatrixGaussian_::forward() {
  #line 34 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  \u03a3->eval();
  #line 35 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  X->eval();
  #line 36 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  Y->eval();
  #line 37 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  return vectorize();
}

#line 40 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 40 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 40 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
libbirch::DefaultArray<Real,1> TestMatrixNormalInverseWishartMatrixGaussian_::backward() {
  #line 41 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(Y->hasValue()));
  #line 42 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  Y->eval();
  #line 43 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(X->hasValue()));
  #line 44 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  X->eval();
  #line 45 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(\u03a3->hasValue()));
  #line 46 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  \u03a3->eval();
  #line 47 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  return vectorize();
}

#line 50 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 50 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 50 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
void TestMatrixNormalInverseWishartMatrixGaussian_::backwardGrad() {
  #line 51 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(Y->hasValue()));
  #line 52 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  Y->eval();
  #line 53 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(X->hasValue()));
  #line 54 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  X->eval();
  #line 55 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  assert(!(\u03a3->hasValue()));
}

#line 60 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 60 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 60 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
Distribution<libbirch::DefaultArray<Real,2>> TestMatrixNormalInverseWishartMatrixGaussian_::marginal() {
  #line 61 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  return Y->getDistribution();
}

#line 64 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 64 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 64 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
libbirch::DefaultArray<Real,1> TestMatrixNormalInverseWishartMatrixGaussian_::vectorize() {
  libbirch::DefaultArray<Real,1> z(libbirch::make_shape(size()));
  auto k = Integer(0);
  #line 67 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + p * p)) = vec(\u03a3->eval());
  #line 68 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  k = k + p * p;
  #line 69 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + n * p)) = vec(X->eval());
  #line 70 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  k = k + n * p;
  #line 71 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + n * p)) = vec(Y->eval());
  #line 72 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  return z;
}

#line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
#line 75 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
Integer TestMatrixNormalInverseWishartMatrixGaussian_::size() {
  #line 76 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  return p * p + Integer(2) * n * p;
}

#line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
TestMatrixNormalInverseWishartMatrixGaussian_* make_TestMatrixNormalInverseWishartMatrixGaussian_() {
  #line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  return new TestMatrixNormalInverseWishartMatrixGaussian_();
  #line 1 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
}

#line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
int test_conjugacy_matrix_normal_inverse_wishart_matrix_gaussian(int argc_, char** argv_) {
  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  int c_, option_index_;
  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  option long_options_[] = {
    #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    {0, 0, 0, 0}
  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  };
  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  const char* short_options_ = ":";
  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  ::opterr = 0;
  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  while (c_ != -1) {
    #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    switch (c_) {
      #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case NFLAG_:
        #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case lazyFLAG_:
        #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 81 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case '?':
        #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case ':':
        #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      default:
        #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  Eigen::initParallel();

  {
    TestMatrixNormalInverseWishartMatrixGaussian m;
    #line 83 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  libbirch::collect();
  #line 80 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  return 0;
}

#line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
int test_pdf_matrix_normal_inverse_wishart_matrix_gaussian(int argc_, char** argv_) {
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer B = Integer(1000);
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer S = Integer(20);
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  int c_, option_index_;
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  option long_options_[] = {
    #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    {0, 0, 0, 0}
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  };
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  const char* short_options_ = ":";
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  ::opterr = 0;
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  while (c_ != -1) {
    #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    switch (c_) {
      #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case NFLAG_:
        #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case BFLAG_:
        #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case SFLAG_:
        #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 87 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 88 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case lazyFLAG_:
        #line 88 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 88 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 88 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 88 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 88 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case '?':
        #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case ':':
        #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      default:
        #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  Eigen::initParallel();

  {
    TestMatrixNormalInverseWishartMatrixGaussian m;
    #line 90 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    m->initialize();
    #line 91 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    m->simulate();
    #line 92 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  libbirch::collect();
  #line 86 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  return 0;
}

#line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
int test_grad_matrix_normal_inverse_wishart_matrix_gaussian(int argc_, char** argv_) {
  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  int c_, option_index_;
  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  option long_options_[] = {
    #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    {0, 0, 0, 0}
  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  };
  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  const char* short_options_ = ":";
  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  ::opterr = 0;
  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  while (c_ != -1) {
    #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    switch (c_) {
      #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case NFLAG_:
        #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case backwardFLAG_:
        #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        if (!::optarg) {
          #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        }
        #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 96 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        break;
      #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case '?':
        #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      case ':':
        #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      default:
        #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  Eigen::initParallel();

  {
    TestMatrixNormalInverseWishartMatrixGaussian m;
    #line 98 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    if (!(backward)) {
      #line 99 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
      warn(String("forward order not supported, switching to backward order"));
    }
    #line 101 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
    test_grad(m, N, true);
  }
  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  libbirch::collect();
  #line 95 "src/test/distribution/matrix_normal_inverse_wishart/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  return 0;
}

}
