namespace birch {
#line 1 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 1 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
TestLinearMatrixNormalInverseWishartMultivariateGaussian_::TestLinearMatrixNormalInverseWishartMultivariateGaussian_() :
    #line 1 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    V(),
    #line 3 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    X(),
    #line 4 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    y(),
    #line 6 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    n(Integer(5)),
    #line 7 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    p(Integer(4)),
    #line 9 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    a((libbirch::make_shape(n))),
    #line 10 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    M((libbirch::make_shape(n, p))),
    #line 11 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    U((libbirch::make_shape(n, n))),
    #line 12 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    c((libbirch::make_shape(p))),
    #line 13 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    k(),
    #line 14 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    \u03a8((libbirch::make_shape(p, p))) {
  //
}

#line 16 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 16 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 16 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
void TestLinearMatrixNormalInverseWishartMultivariateGaussian_::initialize() {
  #line 17 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  k = simulate_uniform(2.0, 10.0);
  #line 18 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  for (auto i = Integer(1); i <= n; ++i) {
    #line 19 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    a(i) = simulate_uniform(-(2.0), 2.0);
    #line 20 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    for (auto j = Integer(1); j <= n; ++j) {
      #line 21 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      U(i, j) = simulate_uniform(-(2.0), 2.0);
    }
    #line 23 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    for (auto j = Integer(1); j <= p; ++j) {
      #line 24 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      M(i, j) = simulate_uniform(-(10.0), 10.0);
    }
  }
  #line 27 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  for (auto i = Integer(1); i <= p; ++i) {
    #line 28 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    c(i) = simulate_uniform(-(10.0), 10.0);
    #line 29 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    for (auto j = Integer(1); j <= p; ++j) {
      #line 30 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      \u03a8(i, j) = simulate_uniform(-(10.0), 10.0);
    }
  }
  #line 33 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  U = outer(U) + diagonal(1.0e-2, n);
  #line 34 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  \u03a8 = outer(\u03a8) + diagonal(1.0e-2, p);
}

#line 37 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 37 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 37 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
void TestLinearMatrixNormalInverseWishartMultivariateGaussian_::simulate() {
  #line 38 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    handle_assume(V, InverseWishart(\u03a8, k));
;
  #line 39 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    handle_assume(X, MatrixGaussian(M, U, V));
;
  #line 40 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    handle_assume(y, MultivariateGaussian(dot(a, X) + c, V));
;
}

#line 43 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 43 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 43 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
libbirch::DefaultArray<Real,1> TestLinearMatrixNormalInverseWishartMultivariateGaussian_::forward() {
  #line 44 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  V->eval();
  #line 45 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  X->eval();
  #line 46 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  y->eval();
  #line 47 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  return vectorize();
}

#line 50 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 50 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 50 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
libbirch::DefaultArray<Real,1> TestLinearMatrixNormalInverseWishartMultivariateGaussian_::backward() {
  #line 51 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  assert(!(y->hasValue()));
  #line 52 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  y->eval();
  #line 53 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  assert(!(X->hasValue()));
  #line 54 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  X->eval();
  #line 55 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  assert(!(V->hasValue()));
  #line 56 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  V->eval();
  #line 57 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  return vectorize();
}

#line 60 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 60 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 60 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
void TestLinearMatrixNormalInverseWishartMultivariateGaussian_::backwardGrad() {
  #line 61 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  assert(!(y->hasValue()));
  #line 62 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  y->eval();
  #line 63 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  assert(!(X->hasValue()));
  #line 64 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  X->eval();
  #line 65 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  assert(!(V->hasValue()));
}

#line 70 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 70 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 70 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
Distribution<libbirch::DefaultArray<Real,1>> TestLinearMatrixNormalInverseWishartMultivariateGaussian_::marginal() {
  #line 71 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  return y->getDistribution();
}

#line 74 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 74 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 74 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
libbirch::DefaultArray<Real,1> TestLinearMatrixNormalInverseWishartMultivariateGaussian_::vectorize() {
  libbirch::DefaultArray<Real,1> z(libbirch::make_shape(size()));
  auto k = Integer(0);
  #line 77 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + p * p)) = vec(V->eval());
  #line 78 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  k = k + p * p;
  #line 79 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + n * p)) = vec(X->eval());
  #line 80 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  k = k + n * p;
  #line 81 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  z(libbirch::make_range(k + Integer(1), k + p)) = y->eval();
  #line 82 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  return z;
}

#line 85 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 85 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
#line 85 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
Integer TestLinearMatrixNormalInverseWishartMultivariateGaussian_::size() {
  #line 86 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  return p * p + n * p + p;
}

#line 1 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
TestLinearMatrixNormalInverseWishartMultivariateGaussian_* make_TestLinearMatrixNormalInverseWishartMultivariateGaussian_() {
  #line 1 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  return new TestLinearMatrixNormalInverseWishartMultivariateGaussian_();
  #line 1 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
}

#line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
int test_conjugacy_linear_matrix_normal_inverse_wishart_multivariate_gaussian(int argc_, char** argv_) {
  #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  int c_, option_index_;
  #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  option long_options_[] = {
    #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  };
  #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  ::opterr = 0;
  #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    switch (c_) {
      #line 91 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case NFLAG_:
        #line 91 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        if (!::optarg) {
          #line 91 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 91 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        }
        #line 91 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 91 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        break;
      #line 91 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case lazyFLAG_:
        #line 91 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        if (!::optarg) {
          #line 91 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 91 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        }
        #line 91 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 91 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        break;
      #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case '?':
        #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case ':':
        #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      default:
        #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMatrixNormalInverseWishartMultivariateGaussian m;
    #line 93 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  libbirch::collect();
  #line 90 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  return 0;
}

#line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
int test_pdf_linear_matrix_normal_inverse_wishart_multivariate_gaussian(int argc_, char** argv_) {
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  [[maybe_unused]] Integer B = Integer(1000);
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  [[maybe_unused]] Integer S = Integer(20);
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  int c_, option_index_;
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  option long_options_[] = {
    #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  };
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  ::opterr = 0;
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    switch (c_) {
      #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case NFLAG_:
        #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        if (!::optarg) {
          #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        }
        #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        break;
      #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case BFLAG_:
        #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        if (!::optarg) {
          #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        }
        #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        break;
      #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case SFLAG_:
        #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        if (!::optarg) {
          #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        }
        #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 97 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        break;
      #line 98 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case lazyFLAG_:
        #line 98 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        if (!::optarg) {
          #line 98 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 98 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        }
        #line 98 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 98 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        break;
      #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case '?':
        #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case ':':
        #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      default:
        #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMatrixNormalInverseWishartMultivariateGaussian m;
    #line 100 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    m->initialize();
    #line 101 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    m->simulate();
    #line 102 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  libbirch::collect();
  #line 96 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  return 0;
}

#line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
int test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian(int argc_, char** argv_) {
  #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  int c_, option_index_;
  #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  option long_options_[] = {
    #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  };
  #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  ::opterr = 0;
  #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    switch (c_) {
      #line 106 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case NFLAG_:
        #line 106 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        if (!::optarg) {
          #line 106 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 106 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        }
        #line 106 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 106 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        break;
      #line 106 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case backwardFLAG_:
        #line 106 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        if (!::optarg) {
          #line 106 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 106 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        }
        #line 106 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 106 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        break;
      #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case '?':
        #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      case ':':
        #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      default:
        #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMatrixNormalInverseWishartMultivariateGaussian m;
    #line 108 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    if (!(backward)) {
      #line 109 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
      warn(String("forward order not supported, switching to backward order"));
    }
    #line 111 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
    test_grad(m, N, true);
  }
  #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  libbirch::collect();
  #line 105 "src/test/distribution/multivariate_normal_inverse_wishart/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  return 0;
}

}
