namespace birch {
}
namespace birch {
#line 157 "src/distribution/multivariate_normal_inverse_gamma/MultivariateNormalInverseGammaDistribution.birch"
#line 157 "src/distribution/multivariate_normal_inverse_gamma/MultivariateNormalInverseGammaDistribution.birch"
libbirch::DefaultArray<Real,1> simulate_multivariate_normal_inverse_gamma(const libbirch::DefaultArray<Real,1>& \u03bd, const libbirch::DefaultArray<Real,2>& \u039b, const Real& \u03b1, const Real& \u03b2) {
  auto \u03a3 = cholinv(\u039b);
  #line 160 "src/distribution/multivariate_normal_inverse_gamma/MultivariateNormalInverseGammaDistribution.birch"
  return simulate_multivariate_t(2.0 * \u03b1, \u03a3 * \u03bd, 2.0 * \u03b2 * \u03a3);
}

}
namespace birch {
#line 141 "src/distribution/multivariate_normal_inverse_gamma/MultivariateNormalInverseGammaMultivariateGaussianDistribution.birch"
#line 141 "src/distribution/multivariate_normal_inverse_gamma/MultivariateNormalInverseGammaMultivariateGaussianDistribution.birch"
libbirch::DefaultArray<Real,1> simulate_multivariate_normal_inverse_gamma_multivariate_gaussian(const libbirch::DefaultArray<Real,1>& \u03bd, const libbirch::DefaultArray<Real,2>& \u039b, const Real& \u03b1, const Real& \u03b2, const libbirch::DefaultArray<Real,2>& \u03a3) {
  auto S = cholinv(\u039b);
  auto \u03bc = S * \u03bd;
  #line 145 "src/distribution/multivariate_normal_inverse_gamma/MultivariateNormalInverseGammaMultivariateGaussianDistribution.birch"
  return simulate_multivariate_t(2.0 * \u03b1, \u03bc, 2.0 * \u03b2 * (\u03a3 + S));
}

}
namespace birch {
#line 147 "src/distribution/multivariate_normal_inverse_gamma/ScaledMultivariateNormalInverseGammaMultivariateGaussianDistribution.birch"
#line 147 "src/distribution/multivariate_normal_inverse_gamma/ScaledMultivariateNormalInverseGammaMultivariateGaussianDistribution.birch"
libbirch::DefaultArray<Real,1> simulate_scaled_multivariate_normal_inverse_gamma_multivariate_gaussian(const libbirch::DefaultArray<Real,2>& A, const libbirch::DefaultArray<Real,1>& \u03bd, const libbirch::DefaultArray<Real,2>& \u039b, const Real& \u03b1, const Real& \u03b2, const libbirch::DefaultArray<Real,2>& \u03a3) {
  auto S = cholinv(\u039b);
  auto \u03bc = S * \u03bd;
  #line 152 "src/distribution/multivariate_normal_inverse_gamma/ScaledMultivariateNormalInverseGammaMultivariateGaussianDistribution.birch"
  return simulate_multivariate_t(2.0 * \u03b1, A * \u03bc, 2.0 * \u03b2 * (\u03a3 + outer(A * S, A)));
}

}
