namespace birch {
#line 1 "src/sampler/ParticleSampler.birch"
#line 1 "src/sampler/ParticleSampler.birch"
ParticleSampler_::ParticleSampler_() :
    #line 1 "src/sampler/ParticleSampler.birch"
    base_type_() {
  //
}

#line 12 "src/sampler/ParticleSampler.birch"
#line 12 "src/sampler/ParticleSampler.birch"
#line 12 "src/sampler/ParticleSampler.birch"
void ParticleSampler_::sample(const ParticleFilter& filter, const Model& model, const Buffer& input) {
  #line 13 "src/sampler/ParticleSampler.birch"
  filter->filter(model, input);
}

#line 23 "src/sampler/ParticleSampler.birch"
#line 23 "src/sampler/ParticleSampler.birch"
#line 23 "src/sampler/ParticleSampler.birch"
void ParticleSampler_::sample(const ParticleFilter& filter, const Integer& t, const Buffer& input) {
  #line 24 "src/sampler/ParticleSampler.birch"
  filter->filter(t, input);
}

#line 35 "src/sampler/ParticleSampler.birch"
#line 35 "src/sampler/ParticleSampler.birch"
#line 35 "src/sampler/ParticleSampler.birch"
void ParticleSampler_::sample(const ParticleFilter& filter, const Integer& t, const Buffer& input, const Kernel& \u03ba) {
  #line 36 "src/sampler/ParticleSampler.birch"
  filter->filter(t, input, \u03ba);
}

#line 42 "src/sampler/ParticleSampler.birch"
#line 42 "src/sampler/ParticleSampler.birch"
#line 42 "src/sampler/ParticleSampler.birch"
std::tuple<Model, Real> ParticleSampler_::draw(const ParticleFilter& filter) {
  #line 43 "src/sampler/ParticleSampler.birch"
  return std::make_tuple(filter->x(filter->b)->m, filter->lnormalize);
}

#line 1 "src/sampler/ParticleSampler.birch"
ParticleSampler_* make_ParticleSampler_() {
  #line 1 "src/sampler/ParticleSampler.birch"
  return new ParticleSampler_();
  #line 1 "src/sampler/ParticleSampler.birch"
}

}
