namespace birch {
#line 1 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 1 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
TestBernoulli_::TestBernoulli_() :
    #line 1 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    base_type_(),
    #line 2 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    x(),
    #line 3 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    \u03c1() {
  //
}

#line 5 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 5 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 5 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
void TestBernoulli_::initialize() {
}

#line 9 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 9 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 9 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
void TestBernoulli_::simulate() {
  #line 10 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    handle_assume(\u03c1, Uniform(0.0, 1.0));
;
  #line 11 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    handle_assume(x, Bernoulli(\u03c1));
;
}

#line 14 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 14 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 14 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
libbirch::DefaultArray<Real,1> TestBernoulli_::forward() {
  #line 15 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  return libbirch::make_array_from_sequence({ x->eval() });
}

#line 18 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 18 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 18 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
libbirch::DefaultArray<Real,1> TestBernoulli_::backward() {
  #line 19 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  return libbirch::make_array_from_sequence({ x->eval() });
}

#line 22 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 22 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 22 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
Distribution<Boolean> TestBernoulli_::marginal() {
  #line 23 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  return x->getDistribution();
}

#line 26 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 26 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
#line 26 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
Integer TestBernoulli_::size() {
  #line 27 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  return Integer(1);
}

#line 1 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
TestBernoulli_* make_TestBernoulli_() {
  #line 1 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  return new TestBernoulli_();
  #line 1 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
}

#line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
int test_pdf_bernoulli(int argc_, char** argv_) {
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  [[maybe_unused]] Integer B = Integer(0);
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  [[maybe_unused]] Integer S = Integer(0);
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  int c_, option_index_;
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  option long_options_[] = {
    #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    {0, 0, 0, 0}
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  };
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  const char* short_options_ = ":";
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  ::opterr = 0;
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  while (c_ != -1) {
    #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    switch (c_) {
      #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
      case NFLAG_:
        #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        if (!::optarg) {
          #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        }
        #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        N = from_string<Integer>(String(::optarg));
        #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        break;
      #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
      case BFLAG_:
        #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        if (!::optarg) {
          #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        }
        #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        B = from_string<Integer>(String(::optarg));
        #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        break;
      #line 32 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
      case SFLAG_:
        #line 32 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        if (!::optarg) {
          #line 32 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 32 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        }
        #line 32 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        S = from_string<Integer>(String(::optarg));
        #line 32 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        break;
      #line 32 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
      case lazyFLAG_:
        #line 32 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        if (!::optarg) {
          #line 32 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 32 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        }
        #line 32 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 32 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        break;
      #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
      case '?':
        #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
      case ':':
        #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
      default:
        #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  Eigen::initParallel();

  {
    TestBernoulli m;
    #line 34 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    m->initialize();
    #line 35 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    m->simulate();
    #line 36 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    test_pdf(m->marginal(), N, lazy);
  }
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  libbirch::collect();
  #line 31 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  return 0;
}

#line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
int test_grad_bernoulli(int argc_, char** argv_) {
  #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  int c_, option_index_;
  #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  option long_options_[] = {
    #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    {0, 0, 0, 0}
  #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  };
  #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  const char* short_options_ = ":";
  #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  ::opterr = 0;
  #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  while (c_ != -1) {
    #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    switch (c_) {
      #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
      case NFLAG_:
        #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        if (!::optarg) {
          #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        }
        #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        N = from_string<Integer>(String(::optarg));
        #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        break;
      #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
      case backwardFLAG_:
        #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        if (!::optarg) {
          #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        }
        #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        break;
      #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
      case '?':
        #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
      case ':':
        #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
      default:
        #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  Eigen::initParallel();

  {
    TestBernoulli m;
    #line 41 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
    test_grad(m, N, backward);
  }
  #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  libbirch::collect();
  #line 39 "src/test/distribution/scalar_boolean/TestBernoulli.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 1 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
TestBetaBernoulli_::TestBetaBernoulli_() :
    #line 1 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    base_type_(),
    #line 2 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    \u03b1(),
    #line 3 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    \u03b2(),
    #line 4 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    \u03c1(),
    #line 5 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    x() {
  //
}

#line 7 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 7 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 7 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
void TestBetaBernoulli_::initialize() {
}

#line 11 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 11 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 11 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
void TestBetaBernoulli_::simulate() {
  #line 12 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    handle_assume(\u03b1, Uniform(1.0, 20.0));
;
  #line 13 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    handle_assume(\u03b2, Uniform(1.0, 20.0));
;
  #line 14 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    handle_assume(\u03c1, Beta(\u03b1, \u03b2));
;
  #line 15 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    handle_assume(x, Bernoulli(\u03c1));
;
}

#line 18 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 18 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 18 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
libbirch::DefaultArray<Real,1> TestBetaBernoulli_::forward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(2)));
  #line 20 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  y(Integer(1)) = \u03c1->eval();
  #line 21 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  y(Integer(2)) = x->eval();
  #line 22 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  return y;
}

#line 25 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 25 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 25 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
libbirch::DefaultArray<Real,1> TestBetaBernoulli_::backward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(2)));
  #line 27 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  assert(!(x->hasValue()));
  #line 28 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  y(Integer(2)) = x->eval();
  #line 29 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  assert(!(\u03c1->hasValue()));
  #line 30 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  y(Integer(1)) = \u03c1->eval();
  #line 31 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  return y;
}

#line 34 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 34 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 34 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
Distribution<Boolean> TestBetaBernoulli_::marginal() {
  #line 35 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  return x->getDistribution();
}

#line 38 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 38 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
#line 38 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
Integer TestBetaBernoulli_::size() {
  #line 39 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  return Integer(2);
}

#line 1 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
TestBetaBernoulli_* make_TestBetaBernoulli_() {
  #line 1 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  return new TestBetaBernoulli_();
  #line 1 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
}

#line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
int test_conjugacy_beta_bernoulli(int argc_, char** argv_) {
  #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  int c_, option_index_;
  #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  option long_options_[] = {
    #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    {0, 0, 0, 0}
  #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  };
  #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  const char* short_options_ = ":";
  #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  ::opterr = 0;
  #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  while (c_ != -1) {
    #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    switch (c_) {
      #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case NFLAG_:
        #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        if (!::optarg) {
          #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        }
        #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        N = from_string<Integer>(String(::optarg));
        #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        break;
      #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case lazyFLAG_:
        #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        if (!::optarg) {
          #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        }
        #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        break;
      #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case '?':
        #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case ':':
        #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      default:
        #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  Eigen::initParallel();

  {
    TestBetaBernoulli m;
    #line 45 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  libbirch::collect();
  #line 43 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  return 0;
}

#line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
int test_pdf_beta_bernoulli(int argc_, char** argv_) {
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  [[maybe_unused]] Integer B = Integer(0);
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  [[maybe_unused]] Integer S = Integer(0);
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  int c_, option_index_;
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  option long_options_[] = {
    #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    {0, 0, 0, 0}
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  };
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  const char* short_options_ = ":";
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  ::opterr = 0;
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  while (c_ != -1) {
    #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    switch (c_) {
      #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case NFLAG_:
        #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        if (!::optarg) {
          #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        }
        #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        N = from_string<Integer>(String(::optarg));
        #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        break;
      #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case BFLAG_:
        #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        if (!::optarg) {
          #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        }
        #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        B = from_string<Integer>(String(::optarg));
        #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        break;
      #line 49 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case SFLAG_:
        #line 49 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        if (!::optarg) {
          #line 49 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 49 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        }
        #line 49 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        S = from_string<Integer>(String(::optarg));
        #line 49 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        break;
      #line 49 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case lazyFLAG_:
        #line 49 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        if (!::optarg) {
          #line 49 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 49 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        }
        #line 49 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 49 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        break;
      #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case '?':
        #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case ':':
        #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      default:
        #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  Eigen::initParallel();

  {
    TestBetaBernoulli m;
    #line 51 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    m->initialize();
    #line 52 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    m->simulate();
    #line 53 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    test_pdf(m->marginal(), N, lazy);
  }
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  libbirch::collect();
  #line 48 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  return 0;
}

#line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
int test_grad_beta_bernoulli(int argc_, char** argv_) {
  #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  int c_, option_index_;
  #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  option long_options_[] = {
    #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    {0, 0, 0, 0}
  #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  };
  #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  const char* short_options_ = ":";
  #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  ::opterr = 0;
  #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  while (c_ != -1) {
    #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    switch (c_) {
      #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case NFLAG_:
        #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        if (!::optarg) {
          #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        }
        #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        N = from_string<Integer>(String(::optarg));
        #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        break;
      #line 57 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case backwardFLAG_:
        #line 57 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        if (!::optarg) {
          #line 57 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 57 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        }
        #line 57 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 57 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        break;
      #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case '?':
        #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      case ':':
        #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
      default:
        #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  Eigen::initParallel();

  {
    TestBetaBernoulli m;
    #line 59 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
    test_grad(m, N, backward);
  }
  #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  libbirch::collect();
  #line 56 "src/test/distribution/scalar_boolean/TestBetaBernoulli.birch"
  return 0;
}

}
