namespace birch {
#line 1 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 1 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
TestChainGaussian_::TestChainGaussian_() :
    #line 1 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    x((libbirch::make_shape(Integer(5)))),
    #line 3 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    \u03bc(),
    #line 4 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    \u03c3((libbirch::make_shape(Integer(5)))) {
  //
}

#line 6 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 6 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 6 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
void TestChainGaussian_::initialize() {
  #line 7 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    handle_assume(\u03bc, Uniform(-(10.0), 10.0));
;
  #line 8 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  for (auto i = Integer(1); i <= Integer(5); ++i) {
    #line 9 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        handle_assume(\u03c3(i), Uniform(0.1, 10.0));
;
  }
}

#line 13 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 13 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 13 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
void TestChainGaussian_::simulate() {
  #line 14 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    handle_assume(x(Integer(1)), Gaussian(\u03bc, \u03c3(Integer(1))));
;
  #line 15 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    handle_assume(x(Integer(2)), Gaussian(x(Integer(1)), \u03c3(Integer(2))));
;
  #line 16 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    handle_assume(x(Integer(3)), Gaussian(x(Integer(2)), \u03c3(Integer(3))));
;
  #line 17 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    handle_assume(x(Integer(4)), Gaussian(x(Integer(3)), \u03c3(Integer(4))));
;
  #line 18 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    handle_assume(x(Integer(5)), Gaussian(x(Integer(4)), \u03c3(Integer(5))));
;
}

#line 21 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 21 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 21 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
libbirch::DefaultArray<Real,1> TestChainGaussian_::forward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(5)));
  #line 23 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  for (auto i = Integer(1); i <= Integer(5); ++i) {
    #line 24 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    y(i) = x(i)->eval();
  }
  #line 26 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  return y;
}

#line 29 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 29 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 29 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
libbirch::DefaultArray<Real,1> TestChainGaussian_::backward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(5)));
  #line 31 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  for (auto i = Integer(0); i <= Integer(4); ++i) {
    #line 32 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    assert(!(x(Integer(5) - i)->hasValue()));
    #line 33 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    y(Integer(5) - i) = x(Integer(5) - i)->eval();
  }
  #line 35 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  return y;
}

#line 38 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 38 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 38 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
Distribution<Real> TestChainGaussian_::marginal() {
  #line 39 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  return x(Integer(5))->getDistribution();
}

#line 42 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 42 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
#line 42 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
Integer TestChainGaussian_::size() {
  #line 43 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  return Integer(5);
}

#line 1 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
TestChainGaussian_* make_TestChainGaussian_() {
  #line 1 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  return new TestChainGaussian_();
  #line 1 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
}

#line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
int test_conjugacy_chain_gaussian(int argc_, char** argv_) {
  #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  int c_, option_index_;
  #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  option long_options_[] = {
    #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {0, 0, 0, 0}
  #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  };
  #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  const char* short_options_ = ":";
  #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  ::opterr = 0;
  #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  while (c_ != -1) {
    #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    switch (c_) {
      #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case NFLAG_:
        #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        if (!::optarg) {
          #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        }
        #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        break;
      #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case lazyFLAG_:
        #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        if (!::optarg) {
          #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        }
        #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        break;
      #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case '?':
        #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case ':':
        #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      default:
        #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  Eigen::initParallel();

  {
    TestChainGaussian m;
    #line 49 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  libbirch::collect();
  #line 47 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  return 0;
}

#line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
int test_pdf_chain_gaussian(int argc_, char** argv_) {
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  [[maybe_unused]] Integer B = Integer(100);
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  [[maybe_unused]] Integer S = Integer(5);
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  int c_, option_index_;
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  option long_options_[] = {
    #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {0, 0, 0, 0}
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  };
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  const char* short_options_ = ":";
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  ::opterr = 0;
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  while (c_ != -1) {
    #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    switch (c_) {
      #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case NFLAG_:
        #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        if (!::optarg) {
          #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        }
        #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        break;
      #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case BFLAG_:
        #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        if (!::optarg) {
          #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        }
        #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        break;
      #line 53 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case SFLAG_:
        #line 53 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        if (!::optarg) {
          #line 53 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 53 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        }
        #line 53 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 53 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        break;
      #line 53 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case lazyFLAG_:
        #line 53 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        if (!::optarg) {
          #line 53 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 53 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        }
        #line 53 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 53 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        break;
      #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case '?':
        #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case ':':
        #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      default:
        #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  Eigen::initParallel();

  {
    TestChainGaussian m;
    #line 55 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    m->initialize();
    #line 56 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    m->simulate();
    #line 57 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  libbirch::collect();
  #line 52 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  return 0;
}

#line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
int test_cdf_chain_gaussian(int argc_, char** argv_) {
  #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  
  enum {
    NFLAG_,
  };
  #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  int c_, option_index_;
  #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  option long_options_[] = {
    #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {0, 0, 0, 0}
  #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  };
  #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  const char* short_options_ = ":";
  #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  ::opterr = 0;
  #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  while (c_ != -1) {
    #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    switch (c_) {
      #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case NFLAG_:
        #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        if (!::optarg) {
          #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        }
        #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        break;
      #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case '?':
        #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case ':':
        #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      default:
        #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  Eigen::initParallel();

  {
    TestChainGaussian m;
    #line 62 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    m->initialize();
    #line 63 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    m->simulate();
    #line 64 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    test_cdf(m->marginal(), N);
  }
  #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  libbirch::collect();
  #line 60 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  return 0;
}

#line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
int test_grad_chain_gaussian(int argc_, char** argv_) {
  #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  int c_, option_index_;
  #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  option long_options_[] = {
    #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    {0, 0, 0, 0}
  #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  };
  #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  const char* short_options_ = ":";
  #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  ::opterr = 0;
  #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  while (c_ != -1) {
    #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    switch (c_) {
      #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case NFLAG_:
        #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        if (!::optarg) {
          #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        }
        #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        break;
      #line 68 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case backwardFLAG_:
        #line 68 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        if (!::optarg) {
          #line 68 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 68 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        }
        #line 68 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 68 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        break;
      #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case '?':
        #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      case ':':
        #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
      default:
        #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  Eigen::initParallel();

  {
    TestChainGaussian m;
    #line 70 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
    test_grad(m, N, backward);
  }
  #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  libbirch::collect();
  #line 67 "src/test/distribution/scalar_gaussian/TestChainGaussian.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 1 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
TestGaussian_::TestGaussian_() :
    #line 1 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    x(),
    #line 3 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    \u03bc(),
    #line 4 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    \u03c32() {
  //
}

#line 6 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 6 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 6 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
void TestGaussian_::initialize() {
  #line 7 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    handle_assume(\u03bc, Uniform(-(10.0), 10.0));
;
  #line 8 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    handle_assume(\u03c32, Uniform(0.1, 10.0));
;
}

#line 11 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 11 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 11 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
void TestGaussian_::simulate() {
  #line 12 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    handle_assume(x, Gaussian(\u03bc, \u03c32));
;
}

#line 15 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 15 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 15 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
libbirch::DefaultArray<Real,1> TestGaussian_::forward() {
  #line 16 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  return libbirch::make_array_from_sequence({ x->eval() });
}

#line 19 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 19 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 19 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
libbirch::DefaultArray<Real,1> TestGaussian_::backward() {
  #line 20 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  return libbirch::make_array_from_sequence({ x->eval() });
}

#line 23 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 23 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 23 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
Distribution<Real> TestGaussian_::marginal() {
  #line 24 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  return x->getDistribution();
}

#line 27 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 27 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
#line 27 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
Integer TestGaussian_::size() {
  #line 28 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  return Integer(1);
}

#line 1 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
TestGaussian_* make_TestGaussian_() {
  #line 1 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  return new TestGaussian_();
  #line 1 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
}

#line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
int test_pdf_gaussian(int argc_, char** argv_) {
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  [[maybe_unused]] Integer B = Integer(100);
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  [[maybe_unused]] Integer S = Integer(5);
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  int c_, option_index_;
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  option long_options_[] = {
    #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    {0, 0, 0, 0}
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  };
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  const char* short_options_ = ":";
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  ::opterr = 0;
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  while (c_ != -1) {
    #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    switch (c_) {
      #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case NFLAG_:
        #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        if (!::optarg) {
          #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        }
        #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        break;
      #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case BFLAG_:
        #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        if (!::optarg) {
          #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        }
        #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        break;
      #line 33 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case SFLAG_:
        #line 33 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        if (!::optarg) {
          #line 33 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 33 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        }
        #line 33 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 33 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        break;
      #line 33 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case lazyFLAG_:
        #line 33 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        if (!::optarg) {
          #line 33 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 33 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        }
        #line 33 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 33 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        break;
      #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case '?':
        #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case ':':
        #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      default:
        #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  Eigen::initParallel();

  {
    TestGaussian m;
    #line 35 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    m->initialize();
    #line 36 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    m->simulate();
    #line 37 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  libbirch::collect();
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  return 0;
}

#line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
int test_cdf_gaussian(int argc_, char** argv_) {
  #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  
  enum {
    NFLAG_,
  };
  #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  int c_, option_index_;
  #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  option long_options_[] = {
    #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    {0, 0, 0, 0}
  #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  };
  #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  const char* short_options_ = ":";
  #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  ::opterr = 0;
  #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  while (c_ != -1) {
    #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    switch (c_) {
      #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case NFLAG_:
        #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        if (!::optarg) {
          #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        }
        #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        break;
      #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case '?':
        #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case ':':
        #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      default:
        #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  Eigen::initParallel();

  {
    TestGaussian m;
    #line 42 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    m->initialize();
    #line 43 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    m->simulate();
    #line 44 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    test_cdf(m->marginal(), N);
  }
  #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  libbirch::collect();
  #line 40 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  return 0;
}

#line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
int test_grad_gaussian(int argc_, char** argv_) {
  #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  int c_, option_index_;
  #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  option long_options_[] = {
    #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    {0, 0, 0, 0}
  #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  };
  #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  const char* short_options_ = ":";
  #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  ::opterr = 0;
  #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  while (c_ != -1) {
    #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    switch (c_) {
      #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case NFLAG_:
        #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        if (!::optarg) {
          #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        }
        #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        break;
      #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case backwardFLAG_:
        #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        if (!::optarg) {
          #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        }
        #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        break;
      #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case '?':
        #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      case ':':
        #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
      default:
        #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  Eigen::initParallel();

  {
    TestGaussian m;
    #line 49 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
    test_grad(m, N, backward);
  }
  #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  libbirch::collect();
  #line 47 "src/test/distribution/scalar_gaussian/TestGaussian.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 1 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
TestGaussianGaussian_::TestGaussianGaussian_() :
    #line 1 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    \u03bc_1(),
    #line 3 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    x(),
    #line 4 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    \u03bc_0(),
    #line 5 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    \u03c32_0(),
    #line 6 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    \u03c32_1() {
  //
}

#line 8 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 8 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 8 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
void TestGaussianGaussian_::initialize() {
  #line 9 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    handle_assume(\u03bc_0, Uniform(-(10.0), 10.0));
;
  #line 10 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    handle_assume(\u03c32_0, Uniform(0.1, 10.0));
;
  #line 11 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    handle_assume(\u03c32_1, Uniform(0.1, 10.0));
;
}

#line 14 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 14 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 14 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
void TestGaussianGaussian_::simulate() {
  #line 15 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    handle_assume(\u03bc_1, Gaussian(\u03bc_0, \u03c32_0));
;
  #line 16 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    handle_assume(x, Gaussian(\u03bc_1, \u03c32_1));
;
}

#line 19 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 19 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 19 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
libbirch::DefaultArray<Real,1> TestGaussianGaussian_::forward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(2)));
  #line 21 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  y(Integer(1)) = \u03bc_1->eval();
  #line 22 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  y(Integer(2)) = x->eval();
  #line 23 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  return y;
}

#line 26 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 26 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 26 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
libbirch::DefaultArray<Real,1> TestGaussianGaussian_::backward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(2)));
  #line 28 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  assert(!(x->hasValue()));
  #line 29 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  y(Integer(2)) = x->eval();
  #line 30 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  assert(!(\u03bc_1->hasValue()));
  #line 31 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  y(Integer(1)) = \u03bc_1->eval();
  #line 32 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  return y;
}

#line 35 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 35 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 35 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
Distribution<Real> TestGaussianGaussian_::marginal() {
  #line 36 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  return x->getDistribution();
}

#line 39 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 39 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
#line 39 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
Integer TestGaussianGaussian_::size() {
  #line 40 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  return Integer(2);
}

#line 1 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
TestGaussianGaussian_* make_TestGaussianGaussian_() {
  #line 1 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  return new TestGaussianGaussian_();
  #line 1 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
}

#line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
int test_conjugacy_gaussian_gaussian(int argc_, char** argv_) {
  #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  int c_, option_index_;
  #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  option long_options_[] = {
    #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {0, 0, 0, 0}
  #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  };
  #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  const char* short_options_ = ":";
  #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  ::opterr = 0;
  #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  while (c_ != -1) {
    #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    switch (c_) {
      #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case NFLAG_:
        #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        if (!::optarg) {
          #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        }
        #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        break;
      #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case lazyFLAG_:
        #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        if (!::optarg) {
          #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        }
        #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        break;
      #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case '?':
        #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case ':':
        #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      default:
        #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  Eigen::initParallel();

  {
    TestGaussianGaussian m;
    #line 46 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  libbirch::collect();
  #line 44 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  return 0;
}

#line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
int test_pdf_gaussian_gaussian(int argc_, char** argv_) {
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  [[maybe_unused]] Integer B = Integer(100);
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  [[maybe_unused]] Integer S = Integer(5);
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  int c_, option_index_;
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  option long_options_[] = {
    #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {0, 0, 0, 0}
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  };
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  const char* short_options_ = ":";
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  ::opterr = 0;
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  while (c_ != -1) {
    #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    switch (c_) {
      #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case NFLAG_:
        #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        if (!::optarg) {
          #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        }
        #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        break;
      #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case BFLAG_:
        #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        if (!::optarg) {
          #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        }
        #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        break;
      #line 50 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case SFLAG_:
        #line 50 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        if (!::optarg) {
          #line 50 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 50 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        }
        #line 50 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 50 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        break;
      #line 50 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case lazyFLAG_:
        #line 50 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        if (!::optarg) {
          #line 50 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 50 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        }
        #line 50 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 50 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        break;
      #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case '?':
        #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case ':':
        #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      default:
        #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  Eigen::initParallel();

  {
    TestGaussianGaussian m;
    #line 52 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    m->initialize();
    #line 53 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    m->simulate();
    #line 54 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  libbirch::collect();
  #line 49 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  return 0;
}

#line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
int test_cdf_gaussian_gaussian(int argc_, char** argv_) {
  #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  
  enum {
    NFLAG_,
  };
  #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  int c_, option_index_;
  #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  option long_options_[] = {
    #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {0, 0, 0, 0}
  #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  };
  #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  const char* short_options_ = ":";
  #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  ::opterr = 0;
  #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  while (c_ != -1) {
    #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    switch (c_) {
      #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case NFLAG_:
        #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        if (!::optarg) {
          #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        }
        #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        break;
      #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case '?':
        #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case ':':
        #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      default:
        #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  Eigen::initParallel();

  {
    TestGaussianGaussian m;
    #line 59 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    m->initialize();
    #line 60 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    m->simulate();
    #line 61 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    test_cdf(m->marginal(), N);
  }
  #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  libbirch::collect();
  #line 57 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  return 0;
}

#line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
int test_grad_gaussian_gaussian(int argc_, char** argv_) {
  #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  int c_, option_index_;
  #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  option long_options_[] = {
    #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    {0, 0, 0, 0}
  #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  };
  #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  const char* short_options_ = ":";
  #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  ::opterr = 0;
  #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  while (c_ != -1) {
    #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    switch (c_) {
      #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case NFLAG_:
        #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        if (!::optarg) {
          #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        }
        #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        break;
      #line 65 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case backwardFLAG_:
        #line 65 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        if (!::optarg) {
          #line 65 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 65 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        }
        #line 65 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 65 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        break;
      #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case '?':
        #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      case ':':
        #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
      default:
        #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  Eigen::initParallel();

  {
    TestGaussianGaussian m;
    #line 67 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
    test_grad(m, N, backward);
  }
  #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  libbirch::collect();
  #line 64 "src/test/distribution/scalar_gaussian/TestGaussianGaussian.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 1 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
TestLinearGaussianGaussian_::TestLinearGaussianGaussian_() :
    #line 1 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    \u03bc_1(),
    #line 3 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    x(),
    #line 4 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    a(),
    #line 5 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    c(),
    #line 6 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    \u03bc_0(),
    #line 7 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    \u03c32_0(),
    #line 8 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    \u03c32_1() {
  //
}

#line 10 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 10 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 10 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
void TestLinearGaussianGaussian_::initialize() {
  #line 11 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    handle_assume(a, Uniform(-(2.0), 2.0));
;
  #line 12 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    handle_assume(c, Uniform(-(10.0), 10.0));
;
  #line 13 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    handle_assume(\u03bc_0, Uniform(-(10.0), 10.0));
;
  #line 14 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    handle_assume(\u03c32_0, Uniform(0.1, 2.0));
;
  #line 15 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    handle_assume(\u03c32_1, Uniform(0.1, 2.0));
;
}

#line 18 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 18 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 18 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
void TestLinearGaussianGaussian_::simulate() {
  #line 19 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    handle_assume(\u03bc_1, Gaussian(\u03bc_0, \u03c32_0));
;
  #line 20 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    handle_assume(x, Gaussian(a * \u03bc_1 + c, \u03c32_1));
;
}

#line 23 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 23 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 23 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
libbirch::DefaultArray<Real,1> TestLinearGaussianGaussian_::forward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(2)));
  #line 25 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  y(Integer(1)) = \u03bc_1->eval();
  #line 26 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  y(Integer(2)) = x->eval();
  #line 27 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  return y;
}

#line 30 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 30 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 30 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
libbirch::DefaultArray<Real,1> TestLinearGaussianGaussian_::backward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(2)));
  #line 32 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  assert(!(x->hasValue()));
  #line 33 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  y(Integer(2)) = x->eval();
  #line 34 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  assert(!(\u03bc_1->hasValue()));
  #line 35 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  y(Integer(1)) = \u03bc_1->eval();
  #line 36 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  return y;
}

#line 39 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 39 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 39 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
Distribution<Real> TestLinearGaussianGaussian_::marginal() {
  #line 40 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  return x->getDistribution();
}

#line 43 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 43 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
#line 43 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
Integer TestLinearGaussianGaussian_::size() {
  #line 44 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  return Integer(2);
}

#line 1 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
TestLinearGaussianGaussian_* make_TestLinearGaussianGaussian_() {
  #line 1 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  return new TestLinearGaussianGaussian_();
  #line 1 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
}

#line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
int test_conjugacy_linear_gaussian_gaussian(int argc_, char** argv_) {
  #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  int c_, option_index_;
  #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  option long_options_[] = {
    #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {0, 0, 0, 0}
  #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  };
  #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  const char* short_options_ = ":";
  #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  ::opterr = 0;
  #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  while (c_ != -1) {
    #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    switch (c_) {
      #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case NFLAG_:
        #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        if (!::optarg) {
          #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        }
        #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        break;
      #line 49 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case lazyFLAG_:
        #line 49 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        if (!::optarg) {
          #line 49 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 49 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        }
        #line 49 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 49 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        break;
      #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case '?':
        #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case ':':
        #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      default:
        #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearGaussianGaussian m;
    #line 51 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  libbirch::collect();
  #line 48 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  return 0;
}

#line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
int test_pdf_linear_gaussian_gaussian(int argc_, char** argv_) {
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  [[maybe_unused]] Integer B = Integer(100);
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  [[maybe_unused]] Integer S = Integer(5);
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  int c_, option_index_;
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  option long_options_[] = {
    #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {0, 0, 0, 0}
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  };
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  const char* short_options_ = ":";
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  ::opterr = 0;
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  while (c_ != -1) {
    #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    switch (c_) {
      #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case NFLAG_:
        #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        if (!::optarg) {
          #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        }
        #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        break;
      #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case BFLAG_:
        #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        if (!::optarg) {
          #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        }
        #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        break;
      #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case SFLAG_:
        #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        if (!::optarg) {
          #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        }
        #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        break;
      #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case lazyFLAG_:
        #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        if (!::optarg) {
          #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        }
        #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 55 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        break;
      #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case '?':
        #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case ':':
        #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      default:
        #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearGaussianGaussian m;
    #line 57 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    m->initialize();
    #line 58 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    m->simulate();
    #line 59 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  libbirch::collect();
  #line 54 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  return 0;
}

#line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
int test_cdf_linear_gaussian_gaussian(int argc_, char** argv_) {
  #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  
  enum {
    NFLAG_,
  };
  #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  int c_, option_index_;
  #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  option long_options_[] = {
    #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {0, 0, 0, 0}
  #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  };
  #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  const char* short_options_ = ":";
  #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  ::opterr = 0;
  #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  while (c_ != -1) {
    #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    switch (c_) {
      #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case NFLAG_:
        #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        if (!::optarg) {
          #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        }
        #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        break;
      #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case '?':
        #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case ':':
        #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      default:
        #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearGaussianGaussian m;
    #line 64 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    m->initialize();
    #line 65 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    m->simulate();
    #line 66 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    test_cdf(m->marginal(), N);
  }
  #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  libbirch::collect();
  #line 62 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  return 0;
}

#line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
int test_grad_linear_gaussian_gaussian(int argc_, char** argv_) {
  #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  int c_, option_index_;
  #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  option long_options_[] = {
    #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    {0, 0, 0, 0}
  #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  };
  #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  const char* short_options_ = ":";
  #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  ::opterr = 0;
  #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  while (c_ != -1) {
    #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    switch (c_) {
      #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case NFLAG_:
        #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        if (!::optarg) {
          #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        }
        #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        break;
      #line 70 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case backwardFLAG_:
        #line 70 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        if (!::optarg) {
          #line 70 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 70 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        }
        #line 70 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 70 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        break;
      #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case '?':
        #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      case ':':
        #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
      default:
        #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearGaussianGaussian m;
    #line 72 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
    test_grad(m, N, backward);
  }
  #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  libbirch::collect();
  #line 69 "src/test/distribution/scalar_gaussian/TestLinearGaussianGaussian.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 1 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
TestLinearMultivariateGaussianGaussian_::TestLinearMultivariateGaussianGaussian_() :
    #line 1 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    \u03bc(),
    #line 3 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    x(),
    #line 5 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    n(Integer(4)),
    #line 7 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    a(),
    #line 8 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    m(),
    #line 9 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    S(),
    #line 10 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    c(),
    #line 11 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    s2() {
  //
}

#line 13 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 13 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 13 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
void TestLinearMultivariateGaussianGaussian_::initialize() {
  #line 14 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    handle_assume(c, Uniform(-(10.0), 10.0));
;
  #line 15 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    handle_assume(a, MultivariateGaussian(vector(0.0, n), diagonal(4.0, n)));
;
  #line 16 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    handle_assume(m, MultivariateGaussian(vector(0.0, n), diagonal(100.0, n)));
;
  #line 17 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    handle_assume(S, MatrixGaussian(matrix(0.0, n, n), diagonal(2.0, n), diagonal(2.0, n)));
;
  #line 18 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    handle_assume(s2, Uniform(0.1, 10.0));
;
}

#line 21 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 21 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 21 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
void TestLinearMultivariateGaussianGaussian_::simulate() {
  #line 22 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    handle_assume(\u03bc, MultivariateGaussian(m, outer(S)));
;
  #line 23 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    handle_assume(x, Gaussian(dot(a, \u03bc) + c, s2));
;
}

#line 26 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 26 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 26 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
libbirch::DefaultArray<Real,1> TestLinearMultivariateGaussianGaussian_::forward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(n + Integer(1)));
  #line 28 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  y(libbirch::make_range(Integer(1), n)) = \u03bc->eval();
  #line 29 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  y(n + Integer(1)) = x->eval();
  #line 30 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  return y;
}

#line 33 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 33 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 33 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
libbirch::DefaultArray<Real,1> TestLinearMultivariateGaussianGaussian_::backward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(n + Integer(1)));
  #line 35 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  assert(!(x->hasValue()));
  #line 36 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  y(n + Integer(1)) = x->eval();
  #line 37 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  assert(!(\u03bc->hasValue()));
  #line 38 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  y(libbirch::make_range(Integer(1), n)) = \u03bc->eval();
  #line 39 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  return y;
}

#line 42 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 42 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 42 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
Distribution<Real> TestLinearMultivariateGaussianGaussian_::marginal() {
  #line 43 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  return x->getDistribution();
}

#line 46 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 46 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
#line 46 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
Integer TestLinearMultivariateGaussianGaussian_::size() {
  #line 47 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  return n + Integer(1);
}

#line 1 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
TestLinearMultivariateGaussianGaussian_* make_TestLinearMultivariateGaussianGaussian_() {
  #line 1 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  return new TestLinearMultivariateGaussianGaussian_();
  #line 1 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
}

#line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
int test_conjugacy_linear_multivariate_gaussian_gaussian(int argc_, char** argv_) {
  #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  int c_, option_index_;
  #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  option long_options_[] = {
    #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {0, 0, 0, 0}
  #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  };
  #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  const char* short_options_ = ":";
  #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  ::opterr = 0;
  #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  while (c_ != -1) {
    #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    switch (c_) {
      #line 52 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case NFLAG_:
        #line 52 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        if (!::optarg) {
          #line 52 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 52 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        }
        #line 52 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 52 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        break;
      #line 52 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case lazyFLAG_:
        #line 52 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        if (!::optarg) {
          #line 52 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 52 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        }
        #line 52 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 52 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        break;
      #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case '?':
        #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case ':':
        #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      default:
        #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMultivariateGaussianGaussian m;
    #line 54 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  libbirch::collect();
  #line 51 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  return 0;
}

#line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
int test_pdf_linear_multivariate_gaussian_gaussian(int argc_, char** argv_) {
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  [[maybe_unused]] Integer B = Integer(100);
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  [[maybe_unused]] Integer S = Integer(5);
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  int c_, option_index_;
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  option long_options_[] = {
    #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {0, 0, 0, 0}
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  };
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  const char* short_options_ = ":";
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  ::opterr = 0;
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  while (c_ != -1) {
    #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    switch (c_) {
      #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case NFLAG_:
        #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        if (!::optarg) {
          #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        }
        #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        break;
      #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case BFLAG_:
        #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        if (!::optarg) {
          #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        }
        #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        break;
      #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case SFLAG_:
        #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        if (!::optarg) {
          #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        }
        #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        break;
      #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case lazyFLAG_:
        #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        if (!::optarg) {
          #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        }
        #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 58 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        break;
      #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case '?':
        #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case ':':
        #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      default:
        #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMultivariateGaussianGaussian m;
    #line 60 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    m->initialize();
    #line 61 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    m->simulate();
    #line 62 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  libbirch::collect();
  #line 57 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  return 0;
}

#line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
int test_cdf_linear_multivariate_gaussian_gaussian(int argc_, char** argv_) {
  #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  
  enum {
    NFLAG_,
  };
  #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  int c_, option_index_;
  #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  option long_options_[] = {
    #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {0, 0, 0, 0}
  #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  };
  #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  const char* short_options_ = ":";
  #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  ::opterr = 0;
  #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  while (c_ != -1) {
    #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    switch (c_) {
      #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case NFLAG_:
        #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        if (!::optarg) {
          #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        }
        #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        break;
      #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case '?':
        #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case ':':
        #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      default:
        #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMultivariateGaussianGaussian m;
    #line 67 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    m->initialize();
    #line 68 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    m->simulate();
    #line 69 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    test_cdf(m->marginal(), N);
  }
  #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  libbirch::collect();
  #line 65 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  return 0;
}

#line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
int test_grad_linear_multivariate_gaussian_gaussian(int argc_, char** argv_) {
  #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  int c_, option_index_;
  #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  option long_options_[] = {
    #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    {0, 0, 0, 0}
  #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  };
  #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  const char* short_options_ = ":";
  #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  ::opterr = 0;
  #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  while (c_ != -1) {
    #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    switch (c_) {
      #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case NFLAG_:
        #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        if (!::optarg) {
          #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        }
        #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        break;
      #line 73 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case backwardFLAG_:
        #line 73 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        if (!::optarg) {
          #line 73 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 73 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        }
        #line 73 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 73 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        break;
      #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case '?':
        #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      case ':':
        #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
      default:
        #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMultivariateGaussianGaussian m;
    #line 75 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
    test_grad(m, N, backward);
  }
  #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  libbirch::collect();
  #line 72 "src/test/distribution/scalar_gaussian/TestLinearMultivariateGaussianGaussian.birch"
  return 0;
}

}
